// -----------------------------------------------------------------
// Ahora el "mpicxx" en MPICH2 reemplaza a la llamada al compilador:
//
//  Compila y enlaza por separado
//   mpicxx -DMPICH_IGNORE_CXX_SEEK -L/usr/local/mpich2-1.0.3/lib 
//     -c hola_cpp.cpp
//   mpicxx -DMPICH_IGNORE_CXX_SEEK -L/usr/local/mpich2-1.0.3/lib 
//     -o hola_cpp.exe hola_cpp.o -lmpich -lpthread  -lrt
//
//  Compila y enlaza de una sola vez
//   mpicxx -DMPICH_IGNORE_CXX_SEEK -L/usr/local/mpich2-1.0.3/lib 
//    -o hola_cpp.exe hola_cpp.cpp -lmpich -lpthread -lrt
//
//  Nota: si ya esta en el PATH donde estan los include de MPI, 
//        entonces no hace falta dar toda la ruta en el fuente, i.e.
//        #include "/usr/local/mpich2-1.0.3/include/mpi.h"
//
// Antes se podia hacerlo por separado, eg. con g++:
//   g++ -w -fpic -I/usr/local/mpich2-1.0.3/include -c hola_cpp.cpp
//   g++ -w -o hola_cpp.exe hola_cpp.o -lc 
//     -L /usr/local/mpich2-1.0.3/lib -lmpich
//
// -----------------------------------------------------------------
// MPD:
//  mpdboot -n 4 -f ~/mpd.hosts
//  mpdtrace
//  mpdringtest
//  mpiexec -machinefile ~/machi.dat -np 4 hola_cpp.exe
//  mpdallexit
//  pdsh -a hostname
//
// -------------------------------------------------------------------
#include <iostream>
#include <mpi.h>
using namespace std;

// -------------------------------------------------------------------
int main (int argc, char * argv []) {
  MPI_Init (& argc, & argv);
  int myid ;
  int siza ;
  MPI_Comm_size (MPI_COMM_WORLD, & siza); // number of processors
  MPI_Comm_rank (MPI_COMM_WORLD, & myid); // my myid in the row of processors
  cout << "hola desde " << myid << " de " << siza << endl ;
  MPI_Finalize ( );
  cout << endl ;
  return 0 ;
} // end main
// -------------------------------------------------------------------
