! -----------------------------------------------------------------
! G95 and MPICH and LD_LIBRARY_PATH:
!  export LD_LIBRARY_PATH="/usr/local/mpich2-1.0.3-g95/lib"
!  g95 -w -fpic -I/usr/local/mpich2-1.0.3-g95/include
!      -c hello_world.f90
!  g95 -w -o hello_world.exe hello_world.o
!      -lc -L/usr/local/mpich2-1.0.3-g95/lib -lmpich
!
! -----------------------------------------------------------------
! G95 and MPICH without LD_LIBRARY_PATH:
!  g95 -w -fpic -I/usr/local/mpich2-1.0.3-g95/include
!      -c hello_world.f90
!  g95 -w -o hello_world.exe hello_world.o
!   -lc -L/usr/local/mpich2-1.0.3-g95/lib -lmpich 
!   -Wl,-E,-rpath,/usr/local/mpich2-1.0.3-g95/lib
!
! -----------------------------------------------------------------
! G95 and MPICH2 with static libraries:
!  g95 -w -fpic -I/usr/local/mpich2-1.0.3-noshared/include 
!      -c hello_world.f90
!  g95 -w -o hello_world.exe hello_world.o 
!       -lc -L/usr/local/mpich2-1.0.3-noshared/lib -lmpich
!
! -----------------------------------------------------------------
! G95 and MPICH2 with dynamic libraries (but with warnings):
!  g95 -w -fpic -I/usr/local/mpich2-1.0.3/include -c hello_world.f90
!  g95 -w -o hello_world.exe hello_world.o -static 
!      -lc -L/usr/local/mpich2-1.0.3/lib -lmpich
!
! -----------------------------------------------------------------
! INTEL and MPICH2 (no-shared):
!   ifort -c -free -auto 
!         -I/usr/local/mpich2-1.0.3-intel-ns/include hello_world.f90
!   ifort -w -o hello_world.exe hello_world.o 
!         -lc -L/usr/local/mpich2-1.0.3-intel-ns/lib -lmpich
! -----------------------------------------------------------------
! INTEL and MPICH and LD_LIBRARY_PATH:
!  export LD_LIBRARY_PATH="/net/local/mpich2-1.0.3/lib"
!  ifort -fpic -I/net/local/mpich2-1.0.3/include -c hola_f90.f90
!  ifort -o hola_f90.exe hola_f90.o -lc -L/net/local/mpich2-1.0.3/lib -lmpich
!
! -----------------------------------------------------------------
! MPD:
!  mpdboot -n 21 -f ~/mpd.hosts
!  mpdtrace
!  mpdringtest
!  mpiexec -machinefile ~/machi.dat -np 3 hello_world.exe
!  mpdallexit
!  pdsh -a hostname
!
! -------------------------------------------------------------------
program hola
  use mpi
  implicit none
  integer :: myid, siza, ierr
  write (*,*)
  call MPI_Init ( ierr )
  call MPI_Comm_size (MPI_COMM_WORLD, siza, ierr) ! nro de proces.
  call MPI_Comm_rank (MPI_COMM_WORLD, myid, ierr) ! my rank
  write (*,*)"hola desde ", myid, " de ", siza
  call MPI_Finalize ( ierr )
  write (*,*)
end program 
! -------------------------------------------------------------------

