! -----------------------------------------------------------------
!  parametros y constantes
module m_ctes
  implicit none
  public
  !
  !parametros de precision usuales
  integer, parameter :: iin = kind (1)
  integer, parameter :: isp = kind (1.0e0)
  integer, parameter :: idp=kind(1.0d0)
  integer, private, parameter :: q=selected_real_kind(2*precision(1.0_idp))
  integer, parameter :: iqp = (1+sign(1,q))/2*q+(1-sign(1,q))/2*idp
  !
  !parametros de precision para el Numerical Recipes (NR)
  integer, parameter :: j4b = selected_int_kind (9)
  integer, parameter :: j2b = selected_int_kind (4)
  integer, parameter :: j1b = selected_int_kind (2)
  !
  !constantes varias
  real (idp), parameter :: cero = 0.0d0
  real (idp), parameter :: uno  = 1.0d0
  real (idp), parameter :: dos  = 2.0d0
  real (idp), parameter :: tres = 3.0d0
  real (idp), parameter :: four = 4.0d0
  real (idp), parameter :: half = 0.5d0
  real (idp), parameter :: tol  = 1.0d-14
  real (idp), parameter :: to12 = 1.0d-12
  real (idp), parameter :: eps  = 1.0d-6
  real (idp), parameter :: eps2 = 1.0d-3
  real (idp), parameter :: cono = 1.0d-3
  real (idp), parameter :: big  = 1.0d+6
  real (idp), parameter :: rmax = 1.0d+8
  real (idp), parameter ::                                    &
     tercio = 0.33333333333333333333333333333333333333333_idp &
   , sexto  = 0.66666666666666666666666666666666666666666_idp
  real (idp), parameter ::                                    &
      pi    = 3.14159265358979323846264338327950288419716_idp &
    , pi050 = 1.57079632679489661923132169163975144209858_idp &
    , pi2   = 6.28318530717958647692528676655900576839400_idp &
    , pi025 = 0.78539816339744828d0                           &
    , cpi2  = 0.63661977236758138d0                           &
    , rpi1  = 0.31830988618379100d0                           &
    , rpi2  = 0.15915494309189500d0                           &
    , rpi4  = 0.07957747154594770d0                           &
    , rpi8  = 0.03978873577297380d0                           &
    , cte_euler = 0.577215664901532860606512d0
   complex (idp), parameter ::                                & 
      znulo = (0.0d0,0.0d0)                                   &
    , zreal = (1.0d0,0.0d0)                                   &
    , zimag = (0.0d0,1.0d0)                                   &
    , zpi2  = (0.0d0,6.28318530717958647692528676655900576d0)
  !
end module
! -----------------------------------------------------------------
