! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! para verificar ram dinamica y tiempos
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
module m_temps
  use  m_ctes
  implicit none
  !
  private           ! por omision todo es asi
  public timer, nerror, ier
  !
  character (10), parameter :: c = "m_temps > "
  !
  ! para verificar alocamiento de memoria RAM
  integer (iin), parameter :: nerror = 64
  integer (iin), dimension (nerror) :: ier
  !
  contains
  !
  !----------------------------------------------------------------
  subroutine timer (time, n, m, raiz)
    real    (idp), dimension (:), intent (inout) :: time
    integer (iin), intent (in)   :: n     ! dimension lineal tipica
    integer (iin), intent (in)   :: m     ! exponente tipico
    character (*), intent (in)   :: raiz  ! raiz archivo
    character (len(raiz)+4) :: arch       ! extension prefijada = 4
    character (4) :: exte = ".tim"        ! aqui la exten. es cte
    character (66):: s
    integer (iin) :: l, p
    integer (iin) :: ntime, h3 
    real    (idp) :: total
    !
    !nro de procesadores
    !p = 1                               ! secuencial 
    p = number_of_processors ()          ! solo en HPF
    !
    !control
    ntime = size (time)
    if (ntime < 2) stop "error (timer): size (time) < 2 "
    !
    !pasa a segundos
    call system_clock (count_rate = h3)  ! cte para pasar a seg
    if (h3 < 1) h3 = 1                   ! control
    time = time / dble (h3)              ! pasa de ciclos a seg
    !
    !tiempo total en ciclos del procesador
    total = sum (time)
    !
    !define archivo
    l = len_trim (raiz)        ! longitud omitiendo blancos
    arch = raiz (1:l) // exte  ! apendiza en ese orden sin blancos
    !
    !resumen a disco
    write (*,*)
    write (*,100) " archivo timer: " // arch
    write (*,*)
    s ="  p            n  k    time columns ... "
    write (*,100) s
    !
    open (1, file = arch         , &
             status = "unknown"  , &
             position = "append")
    write (*,110)  p, n, m, time, total
    write (1,110)  p, n, m, time, total
    close (1, status = 'keep')
    write (*,*)
    !
    ! formatos
    100 format (a)
    110 format (1x, i2, 1x, i12, 1x, i2, 8 (1x, e16.7))
  end subroutine
  !
end module
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
