! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! Matrices ralas: formato (i, j, a_ij). 
! Producto y=Ax con scatter emulado
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! INTEL:
!  ifort -vms -c m_ctes.f90
!  ifort -vms -c m_temps.f90
!  ifort -vms -c rala_csa.f90
!  ifort -vms -o rala_csa.exe1 *.o
!
! GNU:
!  g95 -w -c m_ctes.f90 --free-form
!  g95 -w -c m_tools.f90 --free-form
!  g95 -w -c rala_csa.f90 --free-form
!  g95 -w -o rala_csa.exe2 *.o
!
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program rala_csa
  use m_ctes
  use m_tools
  implicit none
  integer (iin), parameter :: n = 4, p = 7
  integer (iin), dimension (n) :: x, y
  integer (iin), dimension (p) :: a, b
  integer (iin), dimension (p) :: i, j
  !
  write (*,*)
  write (*,*) "Matrices ralas: formato (i,j,a_ij) "
  write (*,*) "producto y=Ax con scatter emulado"
  !
  ! caso n = 4, p = 7
  i = [ 1, 2, 2, 3, 3, 4, 4 ]
  j = [ 2, 1, 3, 1, 3, 2, 4 ]
  b = [ 5, 6, 7, 8, 9, 1, 2 ] 
  x = [ 4, 5, 6, 7 ]
  !
  ! caso n = 7, p = 17
  ! i = [ 1, 4, 6, 2, 3, 1, 3, 5, 4, 2, 5, 7, 3, 6, 7, 5, 7 ]
  ! j = [ 1, 1, 1, 2, 2, 3, 3, 3, 4, 5, 5, 5, 6, 6, 6, 7, 7 ]
  ! b = [ 1, 2, 3, 4, 5, 6, 7, 8, 9, 1, 2, 3, 4, 5, 6, 7, 8 ] 
  ! x = [ 1, 2, 3, 4, 5, 6, 7 ]
  a = b * x (j)
  ! y (1:n) = scatter_add ( a (1:p), y (1:n), i (1:p) )
  call scatter_add ( y (1:n), a (1:p), i (1:p) )
  write (*,*)
  write (*,100)" i          : ", i
  write (*,100)" j          : ", j
  write (*,100)" a          : ", a
  write (*,100)" b          : ", b
  write (*,*)
  write (*,100)" x          : ", x
  write (*,100)"     x(j)   : ", x (j)
  write (*,100)" a * x(j)   : ", b
  write (*,100)" y          : ", y
  write (*,*)
  100 format (a, 10 (1x,i4))
end program 
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
