! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! Ordena un arreglo de enteros por incrementos decrecientes
! en version matricial (cuasi-Shellsort)
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! INTEL:
!  ifort -vms -c shell_sort.f90
!  ifort -vms -o shell_sort.exe1 *.o
!
! GNU:   
!  g95 -w -c shell_sort.f90 --free-form
!  g95 -w -o shell_sort.exe2 shell_sort.o
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program shell_sort
 implicit none
 integer, parameter :: p = 14
 integer, parameter :: kaso = 1
 integer, dimension (:), allocatable :: a
 integer, dimension (p) :: b
 integer :: i, n, ier
 !
 !titulos
 write (*,*)
 write (*,*) "Ordena un arreglo por incrementos decrecientes  "
 write (*,*) "por el metodo de Shellsort, en version matricial"
 !
 !caso pre-definido
 select case (kaso)
 case (1)
   b = [ 14, 7, 12, 5, 10, 3, 8, 6, 13, 4, 11, 2, 9, 1]
   n = size (b)
   allocate ( a (n), stat = ier)
   if (ier .ne. 0) stop" aloca: a "
   a = b
 case default
   write (*,*)
   write (*,*) "tamanio del arreglo ; n : ? " ; read (*,*) n
   allocate ( a (n), stat = ier)
   if (ier .ne. 0)  stop" aloca: a "
   forall (i=1:n)  a (i) = n - i + 1
 end select
 write (*,*)
 write (*,*) "maximo entero representable ; huge = ", huge (1)
 write (*,*) "(usado como eventual relleno al ordenar)"
 write (*,*)
 write (*,*) "arreglo inicial  ; a = ", a
 write (*,*)
 !
 !tarea
 call  qshell (a)
 !
 !salida
 write (*,*)
 write (*,*) "arreglo ordenado ; a = ", a
 write (*,*)
 !
 contains
  subroutine  qshell (a)
   implicit none
   integer, dimension (:), intent (inout) :: a
   integer, dimension (:,:), allocatable :: t
   integer, dimension (2) :: molde
   integer, dimension (size(a)) :: g
   integer :: i, k, n, p
   n = size (a)
   g = huge (a) ! relleno eventual con "infinito" (si hace falta)
   i = n / 2
   i = 2 * i
   iterar: do while (i > 1)
     i = i / 2
     p = (n + i - 1) / i
     allocate ( t (i,p) )
     molde = (/ i , p /)
     t = reshape (source = a, shape = molde, pad = g)
     call  eco (t)
     ordenar: do while ( any (t (:,1:p-1  ) > t (:,2:p  ) ) )
       call  swap (  t (:,1:p-1:2) , t (:,2:p:2)    &
                   , t (:,1:p-1:2) > t (:,2:p:2) )
       call  eco (t)
       call  swap (  t (:,2:p-1:2) , t (:,3:p:2)    &
                   , t (:,2:p-1:2) > t (:,3:p:2) )
       call  eco (t)
     end do ordenar
     a = reshape (t, shape (a) )
     deallocate (t)
    end do iterar
   end subroutine
   ! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
   ! intercambia el contenido de los arreglos "a" y "b"
   subroutine swap (a,b,m)
    integer, dimension (:,:), intent (inout) :: a, b
    logical, dimension (:,:), intent (in)    :: m
    integer, dimension (size(a,1),size(a,2)) :: t
    where (m) ; t = a ; a = b ; b = t ; end where
   end subroutine
   ! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
   ! imprime eco actual por pantalla
   subroutine eco (t)
    integer, dimension (:,:), intent (in) :: t
    integer :: n, i, k
    i = size (t,1) ; k = size (t,2)
    write (*,*)
    imprimir: do  k = 1, i
     write (*,*)" t ", t (k,:)
    end do imprimir
    write (*,*)"pausa ... " ; read (*,*)
   end subroutine
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
