! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! arreglos, intrinsecas: "lbound", "ubound", "shape", "size"
!
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! INTEL:
!  ifort -c proble01.f90
!  ifort -o proble01.exe proble01.o
!
! GNU:   
!  g95 -w -c proble01.f90 --free-form
!  g95 -w -o proble01.exe proble01.o
!  proble01.exe
!
! PGI, F90:   
!  pgf90 -V -Minfo -fast -c proble01.f90
!  pgf90 -V -Minfo -fast -o proble01.exe proble01.o
!
! PGI, HPF:   
!  pghpf -V -Minfo -Mmpi -fast -c proble01.f90
!  pghpf -V -Minfo -Mmpi -fast -o proble01.exe proble01.o
!  mpirun -machinefile machi.dat -np 1 proble01.exe
!
! ADAPTOR for Distributed Memory Machines using MPI:
!  adaptor -hpf -dm -free -c proble01.f90
!  adaptor -hpf -dm -o proble01.exe proble01.o
!  mpirun -machinefile machi.dat -np 1 proble01.exe
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program p01      ! empieza comentario hasta el final de linea
  implicit none  ! obliga a declarar todo identificador
  real   , dimension (1:10)     :: a
  real   , dimension (2,0:2)    :: b
  integer, dimension (-1:1,3,2) :: c
  real   , dimension (0:1,3)    :: d
  !
  write (*,*)
  write (*,*)"Arreglos, intrinsecas: lbound, ubound, shape, size"
  !
  a = 0 ; b = 1 ; c = 2 ; d = 3
  write (*,*)
  write (*,110)" a:",a
  write (*,110)" b:",b
  write (*,100)" c:",c
  write (*,110)" d:",d
  !
  write (*,*)
  write (*,*) "lbound (a) = ", lbound (a)
  write (*,*) "ubound (a) = ", ubound (a)
  write (*,*) "shape  (a) = ", shape  (a)
  write (*,*) "size   (a) = ", size   (a)
  !
  write (*,*)
  write (*,*) "lbound (b) = ", lbound (b)
  write (*,*) "ubound (b) = ", ubound (b)
  write (*,*) "shape  (b) = ", shape  (b)
  write (*,*) "size   (b) = ", size   (b)
  !
  write (*,*)
  write (*,*) "lbound (c) = ", lbound (c)
  write (*,*) "ubound (c) = ", ubound (c)
  write (*,*) "shape  (c) = ", shape  (c)
  write (*,*) "size   (c) = ", size   (c)
  !
  write (*,*)
  write (*,*) "lbound (d) = ", lbound (d)
  write (*,*) "ubound (d) = ", ubound (d)
  write (*,*) "shape  (d) = ", shape  (d)
  write (*,*) "size   (d) = ", size   (d)
  !
  write (*,*)
  100 format (a, 20 (1x, i2, 2x) )
  110 format (a, 16 (1x, f4.1) )
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
