! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! arreglos, intrinsecas "where ... elsewhere ... end where"
!
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! INTEL:
!  ifort -c proble03.f90
!  ifort -o proble03.exe proble03.o
!
! GNU:   
!  g95 -w -c proble03.f90 --free-form
!  g95 -w -o proble03.exe proble03.o
! 
! PGI, F90:   
!  pgf90 -V -Minfo -fast -c proble03.f90
!  pgf90 -V -Minfo -fast -o proble03.exe proble03.o
!
! PGI, HPF:   
!  pghpf -V -Minfo -Mmpi -fast -c proble03.f90
!  pghpf -V -Minfo -Mmpi -fast -o proble03.exe proble03.o
!  mpirun -machinefile machi.dat -np 1 proble03.exe
!
! ADAPTOR for Distributed Memory Machines using MPI:
!  adaptor -hpf -dm -free -c proble03.f90
!  adaptor -hpf -dm -o proble03.exe proble03.o
!  mpirun -machinefile machi.dat -np 1 proble03.exe
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program p03
  implicit none
  real   , dimension (3,4) :: a, b, c
  integer :: i, j, n1, n2
  !
  write (*,*)
  write (*,*) "Arreglos, intrinsecas: where else where " 
  !
  n1 = size (a, dim = 1)
  n2 = size (a, dim = 2)
  write (*,*)
  write (*,*) "size (a, dim = 1) : ", n1
  write (*,*) "size (a, dim = 2) : ", n2
  !
  a = 0.0
  forall (i=2:n1, j=2:n2)  a (i,j) = (i + j) ** 2
  !
  c = 1
  where ( a > 0.0 )  
    b = log (a)
    c = sqrt (a)
  elsewhere
    b = 0.0
  end where
  !
  write (*,*)   ;  write (*,*) "a"
  do  i = 1, n1 ;  write (*,100)  a (i,:)  ;  end do
  !
  write (*,*)   ;  write (*,*) "b"
  do  i = 1, n1 ;  write (*,100)  b (i,:)  ;  end do
  !
  write (*,*)   ;  write (*,*) "c"
  do  i = 1, n1 ;  write (*,100)  c (i,:)  ;  end do
  !
  write (*,*)
  100 format (10 (1x, f6.3) )
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
