! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! arreglos, intrinseca: "reshape" (reformatea arreglo en otro)
!
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! INTEL:
!  ifort -c proble04.f90
!  ifort -o proble04.exe proble04.o
!
! GNU:   
!  g95 -w -c proble04.f90 --free-form
!  g95 -w -o proble04.exe proble04.o
!
! PGI, F90:   
!  pgf90 -V -Minfo -fast -c proble04.f90
!  pgf90 -V -Minfo -fast -o proble04.exe proble04.o
!
! PGI, HPF:   
!  pghpf -V -Minfo -Mmpi -fast -c proble04.f90
!  pghpf -V -Minfo -Mmpi -fast -o proble04.exe proble04.o
!  mpirun -machinefile machi.dat -np 1 proble04.exe
!
! ADAPTOR for Distributed Memory Machines using MPI:
!  adaptor -hpf -dm -free -c proble04.f90
!  adaptor -hpf -dm -o proble04.exe proble04.o
!  mpirun -machinefile machi.dat -np 1 proble04.exe
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program  p04
  implicit none
  integer, dimension (8) :: a = [ 9, 6, 3, 8, 5, 2, 7, 4 ]
  integer, dimension (2) :: molde
  integer, dimension (2,4) :: b
  integer :: i, n, n1, n2
  !
  write (*,*)
  write (*,*) "Arreglos, intrinseca: reshape"
  !
  n  = size (a)
  n1 = size (b, dim = 1)
  n2 = size (b, dim = 2)
  molde = [ n1, n2 ]
  b = reshape (a, molde)
  !
  write (*,*)
  write (*,100) "tamanio = ", n
  write (*,100) "vector  = ", a
  write (*,100) "molde   = ", molde
  write (*,100) "reshape (vector,forma): "
  do  i = 1, n1
    write (*,*) b (i,:)
  end do
  !
  100  format (a,10(1x,i3))
  write (*,*)
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
