! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! arreglos, intrinsecas: "count", "maxval", "maxloc"
!
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! INTEL:
!  ifort -c proble05.f90
!  ifort -o proble05.exe proble05.o
!
! GNU:   
!  g95 -w -c proble05.f90 --free-form
!  g95 -w -o proble05.exe proble05.o
! 
! PGI, F90:   
!  pgf90 -V -Minfo -fast -c proble05.f90
!  pgf90 -V -Minfo -fast -o proble05.exe proble05.o
!
! PGI, HPF:   
!  pghpf -V -Minfo -Mmpi -fast -c proble05.f90
!  pghpf -V -Minfo -Mmpi -fast -o proble05.exe proble05.o
!  mpirun -machinefile machi.dat -np 1 proble05.exe
!
! ADAPTOR for Distributed Memory Machines using MPI:
!  adaptor -hpf -dm -free -c proble05.f90
!  adaptor -hpf -dm -o proble05.exe proble05.o
!  mpirun -machinefile machi.dat -np 1 proble05.exe
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program p05
  implicit none
  integer, dimension (3,4) :: a
  integer, dimension (12) :: v
  integer, dimension (2) :: molde
  integer :: i, j, n1, n2
  !
  write (*,*)
  write (*,*) "Arreglos, intrinsecas: count, maxval, maxloc"
  !
  n1 = size (a, dim = 1)
  n2 = size (a, dim = 2)
  !
  write (*,*)
  write (*,*) "size (a, dim = 1) : ", size (a, dim = 1)
  write (*,*) "size (a, dim = 2) : ", size (a, dim = 2)
  !
  v = [ 3, 1, 0, -4, 3, 2, 8, 5, -5, 6, 4, -1 ]
  molde = [ n1 , n2 ]
  a = reshape (v, molde)
  !
  write (*,*)
  write (*,*) "a : "
  do  i = 1, n1 
    write (*,100) a (i,:)
  end do
  !
  write (*,*)
  write (*,*) "count (a > 0) : ", count (a > 0)
  write (*,*) "count (a < 0) : ", count (a < 0)
  !
  write (*,*)
  write (*,*) "maxloc (a, a < 5): ", maxloc (a, a < 5)
  write (*,*) "maxval (a, a < 5): ", maxval (a, a < 5)
  write (*,*)
  write (*,*) "minloc (a, a < 5): ", minloc (a, a < 5)
  write (*,*) "minval (a, a < 5): ", minval (a, a < 5)
  !
  write (*,*)
  100 format (1x, 10 (1x, i3) )
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
