! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! arreglos, intrinseca: "merge" (superpone 2 arreglos)
!
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! INTEL:
!  ifort -c proble06.f90
!  ifort -o proble06.exe proble06.o
!
! GNU:   
!  g95 -w -c proble06.f90 --free-form
!  g95 -w -o proble06.exe proble06.o
!
! PGI, F90:   
!  pgf90 -V -Minfo -fast -c proble06.f90
!  pgf90 -V -Minfo -fast -o proble06.exe proble06.o
!
! PGI, HPF:   
!  pghpf -V -Minfo -Mmpi -fast -c proble06.f90
!  pghpf -V -Minfo -Mmpi -fast -o proble06.exe proble06.o
!  mpirun -machinefile machi.dat -np 1 proble06.exe
!
! ADAPTOR for Distributed Memory Machines using MPI:
!  adaptor -hpf -dm -free -c proble06.f90
!  adaptor -hpf -dm -o proble06.exe proble06.o
!  mpirun -machinefile machi.dat -np 1 proble06.exe
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program  p06
  implicit none
  !
  logical, parameter :: T = .true.
  logical, parameter :: F = .false.
  !
  integer, dimension (2,3) :: a, b, d
  logical, dimension (2,3) :: c
  integer, dimension (2) :: molde
  integer, dimension (6) :: v1 = [ 2, 8, 4, 6, 6, 4 ]
  integer, dimension (6) :: v2 = [ 1, 7, 3, 9, 5, 3 ]
  logical, dimension (6) :: h  = [ T, F, T, T, F, F ]
  integer :: i, n1, n2
  !
  write (*,*)
  write (*,*) "Arreglos, intrinseca: merge (superpone 2 arreglos)"
  !
  n1 = size (a, dim = 1)
  n2 = size (a, dim = 2)
  molde = [ n1 , n2 ]
  !
  a = reshape (v1, molde)
  b = reshape (v2, molde)
  c = reshape (h, molde)
  !
  d = merge (a, b, c)
  !
  write (*,*)   ;  write (*,*) "a:"
  do  i = 1, n1 ;  write (*,*)  a (i,:)   ; end do
  !
  write (*,*)   ;  write (*,*) "b:"
  do  i = 1, n1 ;  write (*,*)  b (i,:)   ; end do
  !
  write (*,*)   ;  write (*,*) "c:"
  do  i = 1, n1 ;  write (*,*)  c (i,:)   ; end do
  !
  write (*,*)   ;  write (*,*) "merge (a,b,c):"
  do  i = 1, n1 ;  write (*,*)  d (i,:)   ; end do
  !
  100   format (a,10(1x,i3))
  write (*,*)
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
