! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! arreglos, intrinseca: "pack" (compresion de un arreglo)
!
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! INTEL:
!  ifort -c proble07.f90
!  ifort -o proble07.exe proble07.o
!
! GNU:   
!  g95 -w -c proble07.f90 --free-form
!  g95 -w -o proble07.exe proble07.o
!
! PGI, F90:   
!  pgf90 -V -Minfo -fast -c proble07.f90
!  pgf90 -V -Minfo -fast -o proble07.exe proble07.o
!
! PGI, HPF:   
!  pghpf -V -Minfo -Mmpi -fast -c proble07.f90
!  pghpf -V -Minfo -Mmpi -fast -o proble07.exe proble07.o
!  mpirun -machinefile machi.dat -np 1 proble07.exe
!
! ADAPTOR for Distributed Memory Machines using MPI:
!  adaptor -hpf -dm -free -c proble07.f90
!  adaptor -hpf -dm -o proble07.exe proble07.o
!  mpirun -machinefile machi.dat -np 1 proble07.exe
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program  p07
  implicit none
  integer, dimension (2,3) :: a, b
  integer, dimension (6) :: x = [ 1, 2, 3, 4, 5, 6 ]
  integer, dimension (4) :: y = [ 1, 2, 3, 4 ]
  integer, dimension (6) :: z = [ 0, 1, 5, 0, 0, 9 ]
  integer, dimension (2) :: molde
  integer :: i, n1, n2
  !
  write (*,*)
  write (*,*) "Arreglos, intrinseca: pack "
  !
  n1 = size (a, dim = 1)
  n2 = size (a, dim = 2)
  molde = [ n1 , n2 ]
  a = reshape (z, molde)
  b = reshape (z, molde)
  !
  write (*,*)
  write (*,100) "a:"
  do  i = 1, n1 ;  write (*,100) " ", a (i,:) ; end do
  write (*,*)   ;  write (*,100) "x:", x
  !
  write (*,*)
  write (*,100) "pack (a, a.ne.0):"
  write (*,100) " ", pack (a, a .ne. 0)
  !
  write (*,*)
  write (*,100) "pack (a,a.ne.0,vector=x):"
  write (*,100) " ", pack (a,a.ne.0,vector=x)
  !
  write (*,*)
  write (*,100) "b:"
  do  i = 1, n1 ;  write (*,100) " ", b (i,:) ; end do
  write (*,*)   ;  write (*,100) "y:", y
  !
  write (*,*)
  write (*,100) "pack (b, b>0):"
  write (*,100) " ", pack (b, b>0)
  !
  write (*,*)
  write (*,100) "pack (b,a>0,vector=y):"
  write (*,100) " ", pack (b,a>0,vector=y)
  !
  100 format (a,10(1x,i3))
  write (*,*)
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
