! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! arreglos, intrinseca: "unpack" (ecompresion de un arreglo)
!
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! INTEL:
!  ifort -c proble08.f90
!  ifort -o proble08.exe proble08.o
!
! GNU:   
!  g95 -w -c proble08.f90 --free-form
!  g95 -w -o proble08.exe proble08.o
!
! PGI, F90:   
!  pgf90 -V -Minfo -fast -c proble08.f90
!  pgf90 -V -Minfo -fast -o proble08.exe proble08.o
!
! PGI, HPF:   
!  pghpf -V -Minfo -Mmpi -fast -c proble08.f90
!  pghpf -V -Minfo -Mmpi -fast -o proble08.exe proble08.o
!  mpirun -machinefile machi.dat -np 1 proble08.exe
!
! ADAPTOR for Distributed Memory Machines using MPI:
!  adaptor -hpf -dm -free -c proble08.f90
!  adaptor -hpf -dm -o proble08.exe proble08.o
!  mpirun -machinefile machi.dat -np 1 proble08.exe
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program  p08
  implicit none
  !
  logical, parameter :: T = .true.
  logical, parameter :: F = .false.
  !
  integer, dimension (3,3) :: a, d, e
  logical, dimension (3,3) :: b = T
  integer, dimension (5)   :: v = [ 4, 5, 6, 7, 8 ]
  integer :: i, j, p, n, r
  !
  write (*,*)
  write (*,*) "Arreglos, intrinseca: unpack "
  !
  n = size (v)
  p = size (a, dim = 1) 
  !
  a = 0
  forall (i=1:p)  a (i,i) = 1
  b (1,2) = T
  b (2,1) = T
  b (3,3) = T
  !
  d = unpack (v, mask = b, field = r)
  write (*,*)
  write (*,100)" --------------------------------"
  write (*,100) " size (v)   : ", n
  write (*,100) " size (a)   : ", p
  write (*,*)
  write (*,100) " vector  ; v:", v
  write (*,*)
  do  i = 1, p ;  
  write (*,100) " campo   ; a:", a (i,:)
  end do
  write (*,*)
  write (*,100) " mascara ; r:", r
  write (*,*)
  write (*,100) " unpack (v, mask = b, field = r):"
  do  i = 1, p ;  
  write (*,100)" ", d (i,:)   
  end do
  !
  e = unpack (v, mask = b, field =  a)
  write (*,*)
  write (*,100)" --------------------------------"
  write (*,100)" size (v)   : ", n
  write (*,100)" size (a)   : ", p
  write (*,*)
  write (*,100)" vector  ; v:", v
  write (*,*)
  do  i = 1, p ;  
  write (*,100)" campo   ; a:", a (i,:)
  end do
  write (*,*)
  do  i = 1, p ;  
  write (*,110)" mascara ; b:", b (i,:)
  end do
  write (*,*)
  write (*,100)" unpack (v, mask = b, field = a):"
  do  i = 1, p ;  
  write (*,100)" ", e (i,:)   
  end do
  !
  100 format (a,10(1x,i3))
  110 format (a,10(1x,l3))
  write (*,*)
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
