! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! arreglos, instrucciones: "do" y "forall"
!
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! INTEL:
!  ifort -c proble09.f90
!  ifort -o proble09.exe proble09.o
!
! GNU:   
!  g95 -w -c proble09.f90 --free-form
!  g95 -w -o proble09.exe proble09.o
!
! PGI, F90:   
!  pgf90 -V -Minfo -fast -c proble09.f90
!  pgf90 -V -Minfo -fast -o proble09.exe proble09.o
!
! PGI, HPF:   
!  pghpf -V -Minfo -Mmpi -fast -c proble09.f90
!  pghpf -V -Minfo -Mmpi -fast -o proble09.exe proble09.o
!  mpirun -machinefile machi.dat -np 1 proble09.exe
!
! ADAPTOR for Distributed Memory Machines using MPI:
!  adaptor -hpf -dm -free -c proble09.f90
!  adaptor -hpf -dm -o proble09.exe proble09.o
!  mpirun -machinefile machi.dat -np 1 proble09.exe
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program p09
  implicit none
  integer, dimension (5) :: a = [ 11, 22, 33, 44, 55 ]
  integer, dimension (3) :: b = [ 1, 2, 3 ]
  integer, dimension (9) :: v = [ 3, 4, 5, 6, 7, 8, 9, 1, 2 ]
  integer, dimension (2) :: molde
  integer, dimension (3,3) :: d, c
  integer :: i, j, n, n1, n2
  !
  write (*,*)
  write (*,*) "Arreglos, instrucciones do y forall "
  !
  n = size (a)
  write (*,*)
  write (*,100) " dato; a : ", a
  write (*,100) " size (a) : ", n
  !
  do  i = 2, n ;  a (i) = a (i-1) ; end do
  write (*,*)
  write (*,*) "calculo con la instruccion:"
  write (*,*) "do i = 2, n ; a (i) = a (i-1) ; end do "
  write (*,100) " resultado, a : ", a
  !
  a = [ 11, 22, 33, 44, 55 ]
  !
  forall (i = 2 : n)  a (i) = a (i - 1)
  write (*,*)
  write (*,*) "calculo con la instruccion:"
  write (*,*) "forall (i = 2 : n) a (i) = a (i-1) "
  write (*,100) " resultado, a : ", a
  !
  n1 = size (d, dim = 1)
  n2 = size (d, dim = 2)
  molde = [ n1 , n2 ]
  d = reshape (v, molde)
  !
  c = 0
  forall (i = 1 : n1)
    a (i) = b (i)
    forall (j = 1 : i)  c (i,j) = d (i,j)
  end forall
  !
  write (*,*)
  write (*,*) "b:", b
  write (*,*) "a:", a
  !
  write (*,*)   ;  write (*,*) "c:"
  do  i = 1, n1 ;  write (*,*)  c (i,:) ; end do
  !
  write (*,*)   ;  write (*,*) "d:"
  do  i = 1, n1 ;  write (*,*)  d (i,:) ; end do
  !
  100 format (a, 10 (1x,i4))
  !
  write (*,*)
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
