! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! arreglos, intrinseca: "eoshift" (desplazamiento lineal)
!
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! INTEL:
!  ifort -c proble11.f90
!  ifort -o proble11.exe proble11.o
!
! GNU:   
!  g95 -w -c proble11.f90 --free-form
!  g95 -w -o proble11.exe proble11.o
!
! PGI, F90:   
!  pgf90 -V -Minfo -fast -c proble11.f90
!  pgf90 -V -Minfo -fast -o proble11.exe proble11.o
!
! PGI, HPF:   
!  pghpf -V -Minfo -Mmpi -fast -c proble11.f90
!  pghpf -V -Minfo -Mmpi -fast -o proble11.exe proble11.o
!  mpirun -machinefile machi.dat -np 1 proble11.exe
!
! ADAPTOR for Distributed Memory Machines using MPI:
!  adaptor -hpf -dm -free -c proble11.f90
!  adaptor -hpf -dm -o proble11.exe proble11.o
!  mpirun -machinefile machi.dat -np 1 proble11.exe
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program  p11
  implicit none
  integer, dimension (12) :: v
  integer, dimension (2) :: molde
  integer, dimension (3,4) :: u, u1, u2, u3, u4
  integer :: i, n, n1, n2
  !
  write (*,*)
  write (*,*) "Arreglos, intrinseca: eoshift (desplazamiento lineal)"
  !
  v = [ 1, 5, 9, 2, 6, 1, 3, 7, 2, 4, 8, 3 ]
  n = size (v)
  write (*,*) "v: ", v
  write (*,*) "size (v) : ", n
  !
  n1 = size (u1, dim = 1)
  n2 = size (u1, dim = 2)
  molde = [ n1, n2 ]

  u  = reshape (v, molde)  
  u1 = eoshift (u, shift = +1, dim = 1)
  u2 = eoshift (u, shift = -1, dim = 1)
  u3 = eoshift (u, shift = +1, dim = 2)
  u4 = eoshift (u, shift = -1, dim = 2)
  !
  write (*,*)   ;  write (*,*) "u:"
  do  i = 1, n1 ;  write (*,*)  u (i,:)   ; end do
  !
  write (*,*)   ;  write (*,*) "eoshift (u,+1,1):"
  do  i = 1, n1 ;  write (*,*)  u1 (i,:)   ; end do
  !
  write (*,*)   ;  write (*,*) "eoshift (u,-1,1):"
  do  i = 1, n1 ;  write (*,*)  u2 (i,:)   ; end do
  !
  write (*,*)   ;  write (*,*) "eoshift (u,+1,2):"
  do  i = 1, n1 ;  write (*,*)  u3 (i,:)   ; end do
  !
  write (*,*)   ;  write (*,*) "eoshift (u,-1,2):"
  do  i = 1, n1 ;  write (*,*)  u4 (i,:)   ; end do
  !
  100 format (a,10(1x,i3))
  write (*,*)
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
