! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! arreglos: extrae diagonal ppal de una matriz en formato ralo
!
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! INTEL:
!  ifort -c proble12.f90
!  ifort -o proble12.exe proble12.o
!
! GNU:   
!  g95 -w -c proble12.f90 --free-form
!  g95 -w -o proble12.exe proble12.o
!
! PGI, F90:   
!  pgf90 -V -Minfo -fast -c proble12.f90
!  pgf90 -V -Minfo -fast -o proble12.exe proble12.o
!
! PGI, HPF:   
!  pghpf -V -Minfo -Mmpi -fast -c proble12.f90
!  pghpf -V -Minfo -Mmpi -fast -o proble12.exe proble12.o
!  mpirun -machinefile machi.dat -np 1 proble12.exe
!
! ADAPTOR for Distributed Memory Machines using MPI:
!  adaptor -hpf -dm -free -c proble12.f90
!  adaptor -hpf -dm -o proble12.exe proble12.o
!  mpirun -machinefile machi.dat -np 1 proble12.exe
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program  p12
  implicit none
  integer, dimension (11) :: ii = [ 5,2,1,3,4,3,5,4,3,2,1 ]
  integer, dimension (11) :: jj = [ 5,5,1,4,2,3,3,4,1,2,4 ]
  integer, dimension (11) :: aa = [ 1,2,3,4,5,6,7,8,9,1,2 ]
  logical, dimension (11) :: mask
  integer, dimension (:), allocatable :: i
  integer :: k, n, p
  character (64) :: s
  !
  write (*,*)
  write (*,*) "Arreglos: extrae diagonal principal de "
  write (*,*) "          una matriz en formato ralo   "
  !
  n = maxval (ii)
  p = size (ii)
  write (*,*) "nro de incognitas         ; n = ", n
  write (*,*) "nro de coeficientes ralos ; p = ", p
  allocate ( i (n) )
  mask = ( ii (1:p) == jj (1:p) )
  write (*,*)
  write (*,*) "fila matriz rala ; ii   = ", ii
  write (*,*) "colu matriz rala ; jj   = ", jj
  write (*,*) "mascara          ; mask = ", mask
  write (*,*)
  k = count (mask)
  write (*,*) "nro de elementos en la diag ppal hallados ; k = ", k
  i (1:k) = pack (ii (1:p), mask)
  s = "indices de la diagonal principal extraidos de la matriz rala"
  write (*,*)
  write (*,100) s
  write (*,*) i
  !
  100 format (1x, a,10(1x,i3))
  write (*,*)
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
