! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! arreglos: traspuesta usando transpose y forall
!
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! INTEL:
!  ifort -c proble13.f90
!  ifort -o proble13.exe proble13.o
!
! GNU:   
!  g95 -w -c proble13.f90 --free-form
!  g95 -w -o proble13.exe proble13.o
!
! PGI, F90:   
!  pgf90 -V -Minfo -fast -c proble13.f90
!  pgf90 -V -Minfo -fast -o proble13.exe proble13.o
!
! PGI, HPF:   
!  pghpf -V -Minfo -Mmpi -fast -c proble13.f90
!  pghpf -V -Minfo -Mmpi -fast -o proble13.exe proble13.o
!  mpirun -machinefile machi.dat -np 1 proble13.exe
!
! ADAPTOR for Distributed Memory Machines using MPI:
!  adaptor -hpf -dm -free -c proble13.f90
!  adaptor -hpf -dm -o proble13.exe proble13.o
!  mpirun -machinefile machi.dat -np 1 proble13.exe
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program  p13
  implicit none
  integer, parameter :: n = 4
  integer, dimension (n,n) :: a, b, c
  integer :: i, j, s
  !hpf$ distribute (block,block) :: a
  !hpf$ align b (i,j) with a (j,i)
  !hpf$ align c (i,j) with a (j,i)
  !
  write (*,*)
  write (*,*) "Arreglos: traspuesta usando transpose y forall"
  !
  s = 0
  do j = 1, n 
  do i = 1, n 
    s = s + 1
    a (i,j) = s
  end do 
  end do
  !
  b = transpose (a)
  forall (i=1:n,j=1:n) c (j,i) = a (i,j)
  !
  write (*,*)
  write (*,*) "matriz A "
  do  i = 1, n 
  write (*,100) " ", a (i,:)
  end do
  !
  write (*,*)
  write (*,*) "matriz B "
  do  i = 1, n 
  write (*,100) " ", b (i,:)
  end do
  !
  write (*,*)
  write (*,*) "matriz C "
  do  i = 1, n 
  write (*,100) " ", c (i,:)
  end do
  !
  100 format (1x, a,10(1x,i3))
  write (*,*)
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
