# An undocumented switch:
#
#    --disable-aio
#
#    is used as was suggested by the developers (bug report #2524 
#    sent to the "mpich2-maint@mcs.anl.gov")

# verify WHICH version of compilers there are and that they works well
which ifort ; echo $PATH 
ifort hola.f -o hola_f77.exe
ifort hola.f90 -o hola_f90.exe

# environment setting
export F77=g77 ; echo $F77
export F90=ifort ; echo $F90
export F90FLAGS="-Wp,-i4,-xP,-O3,-ipo,-vms,-recursive" ; echo $F90FLAGS 
export PREFIJO="/usr/local/mpich2/1.0.4-ifc" ; echo $PREFIJO

# set dynamic libraries path and path: Intel case
export LD_LIBRARY_PATH="/opt/intel/fc/9.0/lib"
export PATH="$PATH:/opt/intel/fc/9.0/bin"

# control
echo "LD_LIBRARY_PATH = $LD_LIBRARY_PATH"
echo "PATH = $PATH"

# define a construction directory
export BASE="/usr/local/paquetes/mpich2_install/1.0.4" ; echo $BASE
export VERS="mpich2-1.0.4-ifc" ; echo $VERS
cd $BASE ; pwd
tar -zxf mpich2-1.0.4.tar.gz
mv mpich2-1.0.4 $VERS
chown -R root $VERS
chgrp -R users $VERS
chmod -R 777 $VERS
cd $VERS ; pwd

# configure and construction 
./configure --enable-sharedlibs=gcc --enable-fast --enable-mpe --enable-f77 --enable-f90 --disable-aio --prefix=$PREFIJO 2>&1 | tee configure.log
make 2>&1 | tee make.log
make install 2>&1 | tee install.log

# adding the following symbolic link in $PREFIJO/lib
# libpmpich.a -> /usr/local/mpich2/intel/1.0.4/lib/libmpich.a
cd $PREFIJO/lib ; pwd
ln -s $PREFIJO/lib/libmpich.a libpmpich.a

# some tests as "pepe" user
su -l pepe
mpdboot -n 23 -f ~/mpd.hosts
mpdtrace
mpdringtest
echo $LD_LIBRARY_PATH ; which mpdboot ; echo $MPI_ROOT ; echo $PHOME
export BASE="/usr/local/paquetes/mpich2_install/1.0.4" ; echo $BASE
export VERS="mpich2-1.0.4-ifc" ; echo $VERS
cd $BASE ; pwd
cd $VERS ; pwd
make testing 2>&1 | tee testing.log
exit
---
