// -----------------------------------------------------------------
// GNU:
//  compila y enlaza por separado
//   mpicxx -DMPICH_IGNORE_CXX_SEEK -L/usr/local/mpich2-1.0.3/lib -c hola_cpp.cpp
//   mpicxx -DMPICH_IGNORE_CXX_SEEK -L/usr/local/mpich2-1.0.3/lib -o hola_cpp.exe 
//   hola_cpp.o -lmpich -lpthread  -lrt
//
//  compila y enlaza de una sola vez
//   mpicxx -DMPICH_IGNORE_CXX_SEEK -L/usr/local/mpich2-1.0.3/lib -o hola_cpp.exe 
//   hola_cpp.cpp -lmpich -lpthread  -lrt
//
//  nota: si ya esta en el PATH donde esta los include de MPI, entonces 
//        no hace falta dar toda la ruta
//        #include "/usr/local/mpich2-1.0.3/include/mpi.h"
//
//  antes era:
//   g++ -w -fpic -I/usr/local/mpich2-1.0.3/include -c hola_cpp.cpp
//   g++ -w -o hola_cpp.exe hola_cpp.o -lc -L /usr/local/mpich2-1.0.3/lib -lmpich
//   mpirun -machinefile machi.dat -nolocal -np 15 hola_cpp.exe
//
// -------------------------------------------------------------------
#include <iostream>
#include <mpi.h>

using namespace std;

// -------------------------------------------------------------------
int main (int argc, char * argv []) {

  MPI_Init (& argc, & argv);

  int myid ;
  int siza ;

  MPI_Comm_size (MPI_COMM_WORLD, & siza); // number of processors
  MPI_Comm_rank (MPI_COMM_WORLD, & myid); // my myid in the row of processors

  cout << "hola desde " << myid << " de " << siza << endl ;

  MPI_Finalize ( );

  cout << endl ;
  return 0 ;
} // end main
// -------------------------------------------------------------------
