! -----------------------------------------------------------------
! LD_LIBRARY_PATH:
!  export G95="/usr/local/g95"
!  export GFO="/usr/local/gfortran"
!
!  export MPI_103_IFC="/usr/local/mpich2/1.0.3"
!  export MPI_103_G95="/usr/local/mpich2/1.0.3-g95"
!  export MPI_103_GFO="/usr/local/mpich2/1.0.3-gfortran"
!  export MPI_ROOT= ...
!
!  export LD1=$G95/lib
!  export LD2=$GFO/lib
!  export LD3=$MPI_ROOT/lib
!  export LD_LIBRARY_PATH="$LD3:$LD2:$LD1:$LD_LIBRARY_PATH"
!  echo "LD_LIBRARY_PATH = $LD_LIBRARY_PATH"
!
! -----------------------------------------------------------------
! GFORTRAN and MPICH and LD_LIBRARY_PATH:
!  gfortran -c hola_f90.f90 -fpic -I/usr/local/mpich2/1.0.3/include
!  gfortran -o hola_f90.exe hola_f90.o -lc 
!           -L/usr/local/mpich2/1.0.3/lib -lmpich
!
! -----------------------------------------------------------------
! G95 and MPICH and LD_LIBRARY_PATH:
!  g95 -c hola_f90.f90 -fpic -I/usr/local/mpich2/g95/1.0.3/include
!  g95 -o hola_f90.exe hola_f90.o 
!  -lc -L/usr/local/mpich2/1.0.3/g95/lib -lmpich
!  g95 -o hola_f90.exe hola_f90.o 
!  -lc -L/usr/local/mpich2/g95/1.0.3/lib -lmpichf90 -lmpich -lf95 -lm
!
! -----------------------------------------------------------------
! Compilacion "robusta": usar el "driver" de f90 de MPICH:
!  mpif90 -v -o hola_f90.exe hola_f90.f90
!
! -----------------------------------------------------------------
! INTEL: para averiguar los argumentos usar "mpif90 -v ..."
!
!  ifort -c hola_f90.f90 -fpic -I/usr/local/mpich2/1.0.3/include
!  ifort -o hola_f90.exe hola_f90.o 
!        -lc -L/usr/local/mpich2/1.0.3/lib -lmpichf90 -lmpichf90 -lmpich 
! 
!  ifort -c hola_f90.f90 -fpic -I/usr/local/mpich2/1.0.4/include
!  ifort -o hola_f90.exe hola_f90.o -lc -L/usr/local/mpich2/1.0.4/lib 
!        -lmpichf90 -Wl,-rpath -Wl,/usr/local/mpich2/1.0.4/lib 
!        -lmpichf90 -lmpich -lpthread -lrt
!
! -----------------------------------------------------------------
! MPD:
!  mpdboot -n 21 -f ~/mpd.hosts
!  mpdtrace
!  mpdringtest
!  mpiexec -machinefile ~/machi.dat -np 20 hola_f90.exe
!  mpdallexit
!  pdsh -a hostname
!
! -------------------------------------------------------------------
program hola_mundo
  use mpi
  implicit none
  integer :: myid, siza, ierr
  write (*,*)
  call MPI_Init (ierr)
  call MPI_Comm_size (MPI_COMM_WORLD, siza, ierr) ! nro de proces.
  call MPI_Comm_rank (MPI_COMM_WORLD, myid, ierr) ! my rank
  write (*,*)"hola desde ", myid, " de ", siza
  call MPI_Finalize (ierr)
  write (*,*)
end program 
! -------------------------------------------------------------------
