!  -----------------------------------------------------------------
! INTEL: 
!  ifort -c -openmp -fpic -I/opt/intel/fc/9.0/include omp_a03.f90
!  ifort -o omp_a03.exe -openmp -fpic -I/opt/intel/fc/9.0/include omp_a03.f90
!
!  -----------------------------------------------------------------
! PGI:
!  pgf90 -V -Minfo -mp -fast -c omp_a03.f90
!  pgf90 -V -Minfo -mp -fast -o omp_a03_f90.exe omp_a03.o
! 
!  -----------------------------------------------------------------
! ADAPTOR:
!  adaptor -openmp -free -o omp_a03_ada.exe omp_a03.f90
!  export OMP_NUM_THREADS=2 ; echo $OMP_NUM_THREADS
! 
!  -----------------------------------------------------------------
program a03
  implicit none
  integer :: omp_get_thread_num
  integer :: omp_get_num_threads
  integer :: n=7, nh=1, id=0
  !titulos
  write (*,*)
  write (*,*)'A03: using parallel regions '
  write (*,*)
  !tarea demo
  !omp$ parallel shared (n) private (id,nh)
    !$ nh = omp_get_num_threads () 
    !$ id = omp_get_thread_num () 
    if (id == 0) then
      call tarea0 (n,nh)
    else 
      call tarea1 (n,id)
    end if
  !omp$ end parallel
  !finaliza
  write (*,*)
  write (*,*)'finished '
  write (*,*)
  contains
    subroutine tarea0 (n, nh)
     integer, intent (in) :: n
     integer, intent (in) :: nh
     write (*,*) "var. compartida ;  n = ", n
     write (*,*) "nro de hilos    ; nh = ", nh
    end subroutine
    subroutine tarea1 (n, id)
     integer, intent (in) :: n
     integer, intent (in) :: id
     write (*,*) "var. compartida ;  n = ", n
     write (*,*) "hilo            ; id = ", id
    end subroutine
end program
!  =================================================================
