// -----------------------------------------------------------------
// INTEL: 
//  icc -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a04.cpp
//  icc -o omp_a04.exe -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a04.cpp
//
// -----------------------------------------------------------------
// PGI:
//  pgCC -V -Minfo -mp -fast -c omp_a04.cpp
//  pgCC -V -Minfo -mp -fast -o omp_a04_cpp.exe omp_a04.o
//
// -----------------------------------------------------------------
#include <cmath>
#include <iostream>
#ifdef _OPENMP
#include <omp.h>
#endif
using namespace std ;

// -----------------------------------------------------------------
int main () {
  const int n = 100 ;
  float a [n], b [n], c [n] ;
  // titulos
  cout << endl ;
  cout << " A04: using the nowait clause" << endl ;
  cout << endl ;
  // inicializa
  #pragma omp parallel for
  for (int i = 0 ; i < n ; i++) {
    a [i] = (i + 1) * 1.0 ;
  } // end for
  // tarea demo
  #pragma omp parallel
  {
    #pragma omp for nowait
      for (int i = 0 ; i < n ; i++) 
        b [i] = ( a [i] + a [i-1] ) / 2.0 ;
    #pragma omp for nowait
      for (int i = 0 ; i < n ; i++)
        c [i] = sqrt ( b [i] ) ;
  } // end pragma
  // finaliza
  cout << endl ;
  cout << " finished "<< endl ;
  cout << endl ;
  return 0 ;
} // end main
// -----------------------------------------------------------------
