// -----------------------------------------------------------------
// INTEL: 
//  icc -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a05.cpp
//  icc -o omp_a05.exe -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a05.cpp
//
// -----------------------------------------------------------------
// PGI:
//  pgCC -V -Minfo -mp -fast -c omp_a05.cpp
//  pgCC -V -Minfo -mp -fast -o omp_a05_cpp.exe omp_a05.o
//
// -----------------------------------------------------------------
#include <iostream>
#ifdef _OPENMP
#include <omp.h>
#endif
using namespace std ;

// -----------------------------------------------------------------
int  decolar (int x) {return x;} // end int
void trabajo (int x) {         } // end void

// -----------------------------------------------------------------
int main () {
  int x = 1, y = 2, u, v;
  // titulos
  cout << endl ;
  cout << " A05: using the critical directive " << endl ;
  cout << endl ;
  // tarea demo
  #pragma omp parallel shared (x,y) private (u,v)
  {
    #pragma omp critical (xaxis)
      u = decolar (x) ;
      trabajo (u) ;
      cout << " u = "<< u << endl ;
    #pragma omp critical (yaxis)
      v = decolar (y) ;
      trabajo (v) ;
      cout << " v = "<< v << endl ;
  } // end pragma
  // finaliza
  cout << endl ;
  cout << " finished "<< endl ;
  cout << endl ;
  return 0 ;
} // end main
// -----------------------------------------------------------------
