// -----------------------------------------------------------------
// INTEL: 
//  icc -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a06.cpp
//  icc -o omp_a06.exe -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a06.cpp
//
// -----------------------------------------------------------------
// PGI:
//  pgCC -V -Minfo -mp -fast -c omp_a06.cpp
//  pgCC -V -Minfo -mp -fast -o omp_a06_cpp.exe omp_a06.o
//
// -----------------------------------------------------------------
#include <iostream>
#ifdef _OPENMP
#include <omp.h>
#endif
using namespace std ;

// -----------------------------------------------------------------
int main () {
  const int n = 100 ;
  float a [n], b [n] ;
  int   i ;
  // titulos
  cout << endl ;
  cout << " A06: using the lastprivate clause " << endl ;
  cout << endl ;
  // inicializa
  #pragma omp parallel for
  for (i = 0 ; i < n ; i++) {
    a [i] = 0.0 ;
    b [i] = (i + 1) * 1.0 ;
  } // end for
  // tarea demo
  #pragma omp parallel
  {
    #pragma omp for lastprivate (i)
    for (i = 0 ; i < n - 1 ; i++) a [i] = b [i] + b [i + 1] ;
  } // end pragma
  cout << " i     = " << i << endl ;
  cout << " a [i] = " << a [i] << endl ;
  cout << " b [i] = " << b [i] << endl ;
  a [i] = b [i] ;
  // finaliza
  cout << endl ;
  cout << " finished "<< endl ;
  cout << endl ;
  return 0 ;
} // end main
// -----------------------------------------------------------------
