!  -----------------------------------------------------------------
!  INTEL: 
!   ifort -c -openmp -fpic -I/opt/intel/fc/9.0/include omp_a07.f90
!   ifort -o omp_a07.exe -openmp -fpic -I/opt/intel/fc/9.0/include omp_a07.f90
!
!  -----------------------------------------------------------------
!  PGI:
!   pgf90 -V -Minfo -mp -fast -c omp_a07.f90
!   pgf90 -V -Minfo -mp -fast -o omp_a07_f90.exe omp_a07.o
! 
!  -----------------------------------------------------------------
!  ADAPTOR:
!   adaptor -openmp -free -o omp_a07_ada.exe omp_a07.f90
!   export OMP_NUM_THREADS=2 ; echo $OMP_NUM_THREADS
!
!  -----------------------------------------------------------------
program a07
  implicit none
  integer, parameter :: n = 100
  real   , dimension (n) :: x, y
  real    :: a, b
  integer :: i
  !titulos
  write (*,*)
  write (*,*)'A07: using the reduction clause '
  write (*,*)
  !inicializa
  !omp$ do parallel
  do  i = 1, n
    x (i) = i * 1.0
    y (i) = i * 2.0
  end do ! i
  !tarea demo
  !omp$ parallel
    !omp$ parallel do private (i) shared (x,y,n) \
    !omp$ reduction (+:a,b)
     do   i = 1, n
       a = a + x (i)
       b = b + y (i)
     end do ! i
  !omp$ end parallel
  write (*,*)'a = ', a
  write (*,*)'b = ', b
  ! finaliza
  write (*,*)
  write (*,*)'finished '
  write (*,*)
end program
!  =================================================================
