// -----------------------------------------------------------------
// INTEL: 
//  icc -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a10.cpp
//  icc -o omp_a10.exe -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a10.cpp
//
// -----------------------------------------------------------------
// PGI:
//  pgCC -V -Minfo -mp -fast -c omp_a10.cpp
//  pgCC -V -Minfo -mp -fast -o omp_a10_cpp.exe omp_a10.o
//
// -----------------------------------------------------------------
#include <iostream>
#ifdef _OPENMP
#include <omp.h>
#endif
using namespace std ;

// -----------------------------------------------------------------
void work (int i) { 
 #pragma omp ordered
  cout << " i = " << i << endl ; 
} // end void

// -----------------------------------------------------------------
int main () {
  const int n = 10 ;
  int i ;
  // titulos
  cout << endl ;
  cout << " A10: using sequential ordering" << endl ;
  cout << endl ;
  // tarea demo
  #pragma omp for ordered schedule (dynamic)
  for (i = 1 ; i < n ; i++ ) work (i) ;
  // finaliza
  cout << endl ;
  cout << " finished "<< endl ;
  cout << endl ;
  return 0;
} // end main
// -----------------------------------------------------------------
