!  -----------------------------------------------------------------
!  INTEL: 
!   ifort -c -openmp -fpic -I/opt/intel/fc/9.0/include omp_a10.f90
!   ifort -o omp_a10.exe -openmp -fpic -I/opt/intel/fc/9.0/include omp_a10.f90
!
!  -----------------------------------------------------------------
!  PGI:
!   pgf90 -V -Minfo -mp -fast -c omp_a10.f90
!   pgf90 -V -Minfo -mp -fast -o omp_a10_f90.exe omp_a10.o
! 
!  -----------------------------------------------------------------
!  ADAPTOR:
!   adaptor -openmp -free -o omp_a10_ada.exe omp_a10.f90
!   export OMP_NUM_THREADS=2 ; echo $OMP_NUM_THREADS
!
!  -----------------------------------------------------------------
program a10
  implicit none
  integer, parameter :: n = 10
  integer :: i
  !titulos
  write (*,*)
  write (*,*)'A10: using sequential ordering'
  write (*,*)
  !tarea demo
  !omp$ do ordered schedule (dynamic)
    do  i = 1, n
      call work (i)
    end do ! i
  !omp$ end parallel
  !finaliza
  write (*,*)
  write (*,*)'finished '
  write (*,*)
  contains
    subroutine work (i) 
      integer, intent (in) :: i
      !omp$ ordered
      write (*,*)'i = ', i
    end subroutine
end program
!  =================================================================
