// -----------------------------------------------------------------
// INTEL: 
//  icc -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a11.cpp
//  icc -o omp_a11.exe -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a11.cpp
//
// -----------------------------------------------------------------
// PGI:
//  pgCC -V -Minfo -mp -fast -c omp_a11.cpp
//  pgCC -V -Minfo -mp -fast -o omp_a11_cpp.exe omp_a11.o
//
// -----------------------------------------------------------------
#include <iostream>
#ifdef _OPENMP
#include <omp.h>
#endif
using namespace std ;

// -----------------------------------------------------------------
void work (double x,int h, int m) { cout << " h = " << h << endl ; }

// -----------------------------------------------------------------
int main () {
  int m, n = 100, id = 0, nh = 0;
  float x = 1.0 ;
  // titulos
  cout << endl ;
  cout << " A11: specifying a fixed number of threads " << endl ;
  cout << endl ;
  // tarea demo

  #ifdef _OPENMP
   omp_set_dynamic (0);
   omp_set_num_threads (3);
   nh = omp_get_num_threads ();
   cout << " nro de hilos ; nh = " << nh << endl ;
   cout << endl ;
   #pragma omp parallel shared (p, x, n) private (h,m)
   {
     if ( omp_get_num_threads () == 3 ) {
       id = omp_get_thread_num () ;
       m = n / 3 ;
       work (x,id,m); 
     } // end if
   } // end pragma
  #endif
  // finaliza
  cout << endl ;
  cout << " finished "<< endl ;
  cout << endl ;
  return 0 ;
} // end main
// -----------------------------------------------------------------
