!  -----------------------------------------------------------------
!  INTEL: 
!   ifort -c -openmp -fpic -I/opt/intel/fc/9.0/include omp_a11.f90
!   ifort -o omp_a11.exe -openmp -fpic -I/opt/intel/fc/9.0/include omp_a11.f90
!
!  -----------------------------------------------------------------
!  PGI:
!   pgf90 -V -Minfo -mp -fast -c omp_a11.f90
!   pgf90 -V -Minfo -mp -fast -o omp_a11_f90.exe omp_a11.o
! 
!  -----------------------------------------------------------------
!  ADAPTOR:
!   adaptor -openmp -free -o omp_a11_ada.exe omp_a11.f90
!   export OMP_NUM_THREADS=2 ; echo $OMP_NUM_THREADS
!
!  -----------------------------------------------------------------
program a11
  implicit none
  integer :: omp_get_num_threads
  integer :: omp_get_thread_num
  integer :: nh=0, id=0, m, n = 100, p
  real    :: x = 1.0
  !titulos
  write (*,*)
  write (*,*)'A11: specifying a fixed number of threads '
  write (*,*)
  !tarea demo
  !$ call  omp_set_dynamic (.false.)
  !$ call  omp_set_num_threads (3)
  !omp$ parallel shared (x,n) private (id, m)
    !$ nh = omp_get_num_threads () 
    write (*,*) " nh = ", nh
    if (nh == 3) then
      !$ id = omp_get_thread_num ()
      m = n + id
      call work (id,x,m)
    end if
  !omp$ end parallel
  !finaliza
  write (*,*)
  write (*,*)'finished '
  write (*,*)
  contains
    subroutine work (id,x,m)
      integer, intent (in) :: id
      real   , intent (in) :: x
      integer, intent (in) :: m
      write (*,*) "hilo = ", id
      write (*,*) "   x = ", x
      write (*,*) "   m = ", m
    end subroutine
end program
!  =================================================================
