!  -----------------------------------------------------------------
!   INTEL: 
!    ifort -c -openmp -fpic -I/opt/intel/fc/9.0/include omp_a12.f90
!    ifort -o omp_a12.exe -openmp -fpic -I/opt/intel/fc/9.0/include omp_a12.f90
!
!  -----------------------------------------------------------------
!   PGI:
!    pgf90 -V -Minfo -mp -fast -c omp_a12.f90
!    pgf90 -V -Minfo -mp -fast -o omp_a12_f90.exe omp_a12.o
! 
!  -----------------------------------------------------------------
!   ADAPTOR:
!    adaptor -openmp -free -o omp_a12_ada.exe omp_a12.f90
!    export OMP_NUM_THREADS=2 ; echo $OMP_NUM_THREADS
!
!  -----------------------------------------------------------------
program a12
  implicit none
  integer, parameter     :: n = 100
  integer, dimension (n) :: x, y, p
  integer :: i, k
  !titulos
  write (*,*)
  write (*,*)'A12: using the atomic directive '
  write (*,*)
  !inicializa
  !omp$ do
  do   i = 1, n
    x (i) = i + 0
    y (i) = i + 1
    p (i) = n - i
  end do ! i
  !tarea demo
  !omp$ parallel do shared (x,y,p,n) private (k)
  do  i = 1, n 
    k = p (i)
    !omp$ atomic
    x (k) = x (k) + work1 (i)
    y (i) = y (i) + work2 (i)
  end do ! i
  !finaliza
  write (*,*)
  write (*,*)'finished '
  write (*,*)
  contains
    integer function work1 (i) result (j)
      integer, intent (in) :: i
      j = i + 1
    end function
    integer function work2 (i) result (j)
      integer, intent (in) :: i
      j = i + 2
    end function
end program
!  =================================================================
