// -----------------------------------------------------------------
//  INTEL: 
//   icc -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a13.cpp
//   icc -o omp_a13.exe -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a13.cpp
//
// -----------------------------------------------------------------
//  PGI:
//   pgCC -V -Minfo -mp -fast -c omp_a13.cpp
//   pgCC -V -Minfo -mp -fast -o omp_a13_cpp.exe omp_a13.o
//
// -----------------------------------------------------------------
#include <iostream>
#ifdef _OPENMP
#include <omp.h>
#endif
using namespace std ;

// -----------------------------------------------------------------
int laburo (int i) { return (i+1) ; } 

// -----------------------------------------------------------------
int main () {
  const int n = 3 ;
  int  w [n], s [n] ;
  int  nh, id, i = 0, v ;
  // titulos
  cout << endl ;
  cout << " A13: using the flush directive without a list " << endl ;
  // tarea demo  
  #pragma omp parallel private (i,v) shared (w,s)
  { 
    #ifdef _OPENMP
    nh = omp_get_num_threads () ;
    id = omp_get_thread_num () ;
    #endif
    i = id ;   
    s [i] = 0 ;
    #pragma omp barrier
    // do computation into my portion of the work array
    w [i] = laburo (i) ;
    // Announce that I am doe my work:
    // The first  flush ensures that my work is visible before "s"
    // The second flush ensures that "s" is made visible
    #pragma omp flush (w)
    s [i] = 1 ;
    #pragma omp flush (s)
    // wait for the neighbor
    if (i > 0) 
      v = i - 1 ; 
    else { 
      v = nh - 1 ;
    } // end 
    while ( s [v] == 0 ) {
      #pragma omp flush (s)
    } // end while
    // read neighbor values from the work array
    // ... = w [v] ;
  } // end pragma
  // finaliza
  cout << endl ;
  cout << " finished "<< endl ;
  cout << endl ;
  return 0 ;
} // end main
// -----------------------------------------------------------------
