// -----------------------------------------------------------------
// INTEL: 
//  icc -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a14.cpp
//  icc -o omp_a14.exe -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a14.cpp
//
// -----------------------------------------------------------------
// PGI:
//  pgCC -V -Minfo -mp -fast -c omp_a14.cpp
//  pgCC -V -Minfo -mp -fast -o omp_a14_cpp.exe omp_a14.o
//  omp_a14_cpp.exe
//
// -----------------------------------------------------------------
#include <iostream>
#ifdef _OPENMP
#include <omp.h>
#endif
using namespace std ;

// -----------------------------------------------------------------
const int k = 7 ;
int  x = 0, *p = &x ;
int  h = 0, *j = &h ;

// -----------------------------------------------------------------
void f1 (int *q) {
 *q = 1 ;
 #pragma omp flush
 // x, p, *q are flushed since they are shared and accessible
 // while q is not flushed since it is not shared.
} // end void

// -----------------------------------------------------------------
void f2 (int *q) {
 #pragma omp barrier
 *q = 2 ;
 #pragma omp barrier
 // a barrier implies a flus 
 // x, p, *q  are flushed since they are shared and accessible
 // while q is not flushed since it is not shared.
} // end void

// -----------------------------------------------------------------
int g (int n) {
  int i = 1, suma = 0 ;
  *p = 1 ;
  #pragma omp parallel reduction (+:suma) num_threads (2)
  {
   f1 (j) ;
   // i, n, suma were not flushed since they were not accessible 
   // in f1 while j was flushed since it was accessible
   suma = suma + *j ;
   f2 (j) ;
   // i, n, suma were not flushed since they were not accessible 
   // in f2 while j was flushed since it was accessible
   suma = suma + i + *j + *p + n ;
  }
 return suma;
} // end int

// -----------------------------------------------------------------
int main () {
  cout << endl ;
  cout << " A14: using the flush directive without a list " << endl ;
  cout << endl ;
  cout << " k     = " << k     << endl ;
  cout << " G (k) = " << g (k) << endl ;
  cout << endl ;
  return 0 ;
} // end main
// -----------------------------------------------------------------
