// -----------------------------------------------------------------
// INTEL: 
//  icc -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a15.cpp
//  icc -o omp_a15.exe -c -openmp -fpic -I/opt/intel/cc/9.0/include omp_a15.cpp
//
// -----------------------------------------------------------------
// PGI:
//  pgCC -V -Minfo -mp -fast -c omp_a15.cpp
//  pgCC -V -Minfo -mp -fast -o omp_a15_cpp.exe omp_a15.o
//
// -----------------------------------------------------------------
#include <iostream>
#ifdef _OPENMP
#include <omp.h>
#endif
using namespace std ;

// -----------------------------------------------------------------
void work (int i) { cout << " i = " << i << endl ; }

// -----------------------------------------------------------------
int main () {
  int  id = 0 ;
  // titulos
  cout << endl ;
  cout << " A15: determining the number of threads used" << endl ;
  cout << endl ;
  // tarea demo
  #pragma omp parallel private (i)
  {
    #ifdef _OPENMP
    id = omp_get_thread_num (); // debe estar dentro de zona paralela
    #endif
    work (id) ;
  } // end pragma
  // finaliza
  cout << endl ;
  cout << " finished "<< endl ;
  cout << endl ;
  return 0 ;
} // end main
// -----------------------------------------------------------------
