! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! INTEL:
!  ifort -o dotsub.exe -openmp -fpic -I/opt/intel/fc/9.0/include dotsub.f90
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program dotsub
  implicit none
  integer, parameter :: n = 10
  integer, parameter :: ip = kind (1.0d0)
  real (kind=ip) :: s = 0.0_ip
  real (kind=ip), dimension (n) :: a = 1.0_ip, b = 2.0_ip
  b (3:7) = 0.0_ip
  !$omp parallel shared (a,b,s)
    s = dot (a,b)
  !$omp end parallel
  print*, "a", a
  print*, "b", b
  print*, "s", s
  contains
    function dot (a,b)
      real (kind=ip), dimension (:), intent (in) :: a, b
      real (kind=ip) :: dot
      real (kind=ip) :: s = 0.0_ip
      integer :: i, n
      n = size (a)
      !$omp do reduction (+:s)
      do i = 1, n
        s = s + a (i) * b(i)
      end do
      !$omp end do
      dot = s
    end function
end program
