! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! INTEL:
!  ifort -o matvec.exe -openmp -fpic -I/opt/intel/fc/9.0/include matvec.f90
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program matvec
  implicit none
  integer, parameter :: n = 4
  integer, parameter :: ip = selected_real_kind (12,100)
  integer :: i, j
  real (kind=ip), dimension (n) :: v, r = 0.0_ip
  real (kind=ip), dimension (n,n) :: a
  v = 1.0_ip
  call random_number (a)
  !$omp parallel shared (a,v,r)
    !$omp do
    do j = 1, n
      do i = 1, n
        r (i) = r (i) + a (i,j) * v (j)
      end do
    end do
    !$omp end do
  !$omp end parallel
  print*, "a", a
  print*, "v", v
  print*, "r", r
end program
