! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! Compilation with INTEL:
!  ifort -w -c type.f90
!  ifort -w -o type.exe2 type.o
!
! Compilation with GNU:
!  g95 -w -o type.exe2 type.f90
!
! Compilation with (ADAPTOR + MPICH):
!  adaptor -hpf -dm -free -c type.f90
!  adaptor -hpf -dm -free -o type.exe2 *.o
!
! Running with MPICH:
!  mpdboot -n 21 -f ~/mpd.hosts
!  mpdtrace
!  mpiexec -machinefile ~/machi.dat -np 2 type.exe2
!  mpiexec -machinefile ~/machi.dat -1 -np 4 type.exe2
!  mpdallexit
!
! The same running but with MPI (old):
!  mpirun -machinefile ~/machi.dat -np 2 type.exe2
!  mpirun -machinefile ~/machi.dat -nolocal -np 4 type.exe2
!
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program ppal
  implicit none
  !
  type rec1
    integer n
    integer, pointer, dimension (:) :: f
  end type
  type (rec1), allocatable, dimension (:) :: grids
  !
  integer :: i, k, m
  integer :: s, s1
  ! 
  print *
  print *, "mapping of arrays containting derived types ... "
  print *
  print *, "input M : ? "
  read  *, m
  !
  print *, "aloca datos ... "
  allocate (grids (m) )
  do  k = 1, m
    grids (k) % n = k
    allocate (grids (k) % f (1:k))
  end do
  !
  print *, "inicializa datos ..."
  do  k = 1, m
    grids (k) % f = [ (i, i=1,k) ]
  end do
  !
  print *, "sumando ... "  
  s = 0
  do  k = 1, M
    s = s + sum (grids (k) % f)
  end do
  !
  s1 = 0 
  do  k = 1, m
    s1 = s1 + k * (k + 1) / 2
  end do
  !
  print *, "suma = ", s, " deberia ser ", s1
  !
  print *, "dloca datos ... "
  do  k = 1, m
    deallocate (grids (k) % f)
  end do
  deallocate (grids)
  !
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
