! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! Compilation with INTEL:
!  ifort -w -c mapped.f90
!  ifort -w -o mapped.exe2 *.o
!
! Compilation with GNU:
!  g95 -w -o mapped.exe2 mapped.f90
!
! Compilation with (ADAPTOR + MPICH):
!  adaptor -hpf -dm -free -c mapped.f90
!  adaptor -hpf -dm -free -o mapped.exe2 *.o
!
! Running with MPICH:
!  mpdboot -n 21 -f ~/mpd.hosts
!  mpdtrace
!  mpiexec -machinefile ~/machi.dat -np 2 mapped.exe2
!  mpiexec -machinefile ~/machi.dat -1 -np 4 mapped.exe2
!  mpdallexit
!
! The same running but with MPI (old):
!  mpirun -machinefile ~/machi.dat -np 2 mapped.exe2
!  mpirun -machinefile ~/machi.dat -nolocal -np 4 mapped.exe2
!
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program test
  implicit none
  integer, parameter :: n = 5
  integer :: i
  !
  type t
    integer a (n)
    !hpf$  distribute a (block)
    !adp$  descriptor a
  end type t
  !
  type (t), allocatable, dimension (:) :: x
  ! 
  print *
  print *, "derived types with mapped arrays ... "
  !
  print *
  print *, "n = ", n
  !
  allocate ( x (n+1) )
  x (1) % a = [ (i, i=1, n) ]
  print *
  print *, "arreglo inicial en x (1) ", x (1) % a
  !
  do  i = 2, (n+1)
    ! x (i) % a = cshift (x (i-1) % a, dim=1, shift=1)
      x (i) % a = x (i-1) % a + 1
  end do
  !
  print *
  print *, "arreglo final en x (n+1) ", x (n+1) % a
  !
  if (any (x (1) % a + n .ne. x (n+1) % a)) then
    print *, "ERROR"
    print *, x (1) % a
    print *, x (n+1) % a
  else
    print *, "PASSED"
  end if
  !
  deallocate (x)
  print *
  !
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
