! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
!
! compilation with (adaptor + mpich):
!  adaptor -hpf -dm -free -o embedding.exe embedding.f90
!
! running with mpich:
!  mpdboot -n 21 -f ~/mpd.hosts
!  mpdtrace
!  mpiexec -machinefile ~/machi.dat -np 2 embedding.exe
!  mpdallexit
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program embedding_test
  implicit none
  integer, parameter :: n = 16
  integer :: errata
  integer :: np
  integer, dimension (n) :: da
  !hpf$ distribute (block) :: da
  integer :: s
  print *
  print *, "test embedded alignments"
  print *, "========================"
  print *
  errata = 0
  np = number_of_processors ()
  call test1 (errata, n)
  !make sure that no processor hangs
  da = 1
  s = sum (da)
  if (errata .eq. 0) then
    print *, "home np =", np, ": all tests passed"
  else
    print *, "home np =", np, ": at least one test Failed"
  end if
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
subroutine test1 (errata, n)
  implicit none
  integer, intent (in) :: errata, n
  integer :: i, j
  real, parameter :: val = 5.0
  real, dimension (n,n) :: a, b
  !hpf$ template t (2,2) 
  !hpf$ distribute (block, block) :: t
  !hpf$ align a (i,j) with t(1,2)
  !hpf$ align b (i,j) with t(2,1)
  a = val
  b = 3.0
  !tests home_set_var, home_assign
  b(3,4) = a(n-4,n-3)
  if (b(3,4) .ne. val) then
    print *, "test1: ", b(3,4), " should be ", val
    errata = errata + 1
  end if
end subroutine
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
