! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
!
! compilation with (adaptor + mpich):
!  adaptor -hpf -dm -free -o gather.exe gather.f90
!
! running with mpich:
!  mpdboot -n 21 -f ~/mpd.hosts
!  mpdtrace
!  mpiexec -machinefile ~/machi.dat -np 2 gather.exe
!  mpdallexit
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
!     basic test program for unstructured ghater
program ghater
  implicit none
  integer, parameter :: n=100
  integer :: errata, k
  print *
  print *, "test of unstructured ghater"
  print *, "==========================="
  print *
  print *, "dimension (",n,")"
  errata = 0
  print *, "ghater test "
  call ghater_test  (n, k, errata)
  call ghater_rtest (n, k, errata)
  print *
  if (errata .eq. 0) then
    print *, "dalib-gather: all tests PAssed"
  else
    print *, "dalib-gather: at least one test FAiLed"
  end if
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
subroutine ghater_test (n, k, errata)
  implicit none
  integer, intent (in)    :: n, k
  integer, intent (inout) :: errata
  integer, dimension (n) :: x1, x2
  integer, dimension (n) :: ind
  integer :: i
  !hpf$ distribute (block) :: x1, x2, ind
  x1  = [ (i, i=1,n) ]
  ind = [ (i, i=n,1,-1) ]
  x2 = x1 (ind)
  if (any (x2 .ne. [ (i, i=n,1,-1) ])) then
    errata = errata + 1
    print *, " --> error for gather  ", x2
  end if
end subroutine
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
subroutine ghater_rtest (n, k, errata)
  implicit none
  integer, intent (in)   :: n, k
  integer, intent (inout):: errata
  integer, dimension (n) :: x1, x2, x3
  integer, dimension (n) :: ind
  integer :: i
  !hpf$ distribute (block) :: x1, x2, x3, ind
  x1  = [ (i, i=1,n) ]
  ind = [ (i, i=n,1,-1) ]
  x2  = 0
  x3  = ind
  forall (i=1:n:2)
    x2 (i) = x1 (ind(i))
  end forall
  forall (i=2:n:2)
    x3 (i) = 0
  end forall
  if (any (x2 .ne. x3)) then
    errata = errata + 1
    print *, " --> error for gather  ", x2
  end if
end subroutine
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
