! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
!
! compilation with (adaptor + mpich):
!  adaptor -hpf -dm -free -o red_dir.exe red_dir.f90
!
! running with mpich:
!  mpdboot -n 21 -f ~/mpd.hosts
!  mpdtrace
!  mpiexec -machinefile ~/machi.dat -np 6 red_dir.exe
!  mpdallexit
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program red_test
  implicit none
  integer, parameter :: n = 100
  integer, dimension (n) :: a, b, index
  real, dimension (n) :: rb
  !hpf$ distribute (block) :: a, b, index, rb
  integer :: i, errata = 0
  !
  print *
  print *, "Test Reduction Directive"
  print *, "========================"
  print *
  !
  call random_number (rb)
  index = rb * n + 1
  call random_number (rb)
  !
  a = rb * n + 1
  b = 0
  !
  !hpf$ independent, on home (a(i)), reduction (b)
  do  i = 1, n
    b (index(i)) = b (index(i)) + a(i)
  end do
  !
  if (sum(b) .ne. sum(a) ) then
     print *, "REDUCTION ERROR"
     errata = errata + 1
  end if
  !
  b = 0
  !hpf$ independent, on home (a(i)), reduction(b)
  do  i = 1, n
    !adp$ atomic
     b (index(i)) = b(index(i)) + a(i)
  end do
  !
  if (sum(b) .ne. sum(a)) then
     print *, "ATOMIC REDUCTION ERROR"
     errata = errata + 1
  end if
  if (errata .eq. 0) then
     print *, "REDDIR: all tests PASSED"
  else
     print *, "REDDIR: at least one test FAILED"
  end if
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
