! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
!
! compilation with (adaptor + mpich):
!  adaptor -hpf -dm -free -o redist.exe redist.f90
!
! running with mpich:
!  mpdboot -n 21 -f ~/mpd.hosts
!  mpdtrace
!  mpiexec -machinefile ~/machi.dat -np 6 redist.exe
!  mpdallexit
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program dinamico
  implicit none
  integer, parameter :: n1 = 10, n2 = 5
  integer, dimension (n1, n2) :: v          ! for comparison
  integer, dimension (n1, n2) :: a, b
  real   , dimension (n1, n2)    :: r
  !hpf$ distribute (*,block) :: v, a, r
  !hpf$ align b with a
  !hpf$ dynamic :: a, b
  integer :: k
  integer :: errata = 0 , np
  !
  np = number_of_processors ()
  print *
  print *, "Test explicit redistribution on ",np," procs"
  print *, "============================================"
  print *
  !
  !get random numbers for testing 
  call random_number (r)
  v = r * float (n1*n2)
  a = v
  b = v
  do  k = 1, 10
    !hpf$ redistribute (*,block) :: a
    !hpf$ realign with a :: b
     a = a + 1
     b = b - 1
     !hpf$ redistribute (block,*) :: a
     !hpf$ realign with a :: b
     a = a - 1
     b = b + 1
  end do
  !hpf$ redistribute (*,block) :: a
  !hpf$ realign with a :: b      
  if (any (a .ne. v)) then
     errata = errata + 1
     print *, "v = ", v
     print *, "a = ", a
  end if
  if (any (b .ne. v)) then
     errata = errata + 1
     print *, "v = ", v
     print *, "b = ", b
  end if
  print *
  if (errata .eq. 0) then
     print *, "Redist np =", np, ": all tests PASSED"
    else
     print *, "Redist np =", np, ": at least one test FAILED"
  end if
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
