! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
!
! compilation with (adaptor + mpich):
!  adaptor -hpf -dm -free -o alignment.exe alignment.f90
!
! running with mpich:
!  mpdboot -n 21 -f ~/mpd.hosts
!  mpdtrace
!  mpiexec -machinefile ~/machi.dat -np 2 alignment.exe
!  mpdallexit
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program lib_test
  implicit none
  real, dimension (10,10) :: a
  integer :: i, j
  !hpf$ template, dimension (40,40) :: t
  !hpf$ align a (i,j) with t (1+3*i,2*j)
  !hpf$ distribute t (block,block)
  !
  print *, "ALIGNMENT of A"
  call SHOW_ALIGNMENT (A)
  !
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
extrinsic (HPF_LOCAL) subroutine SHOW_ALIGNMENT (x)
  use HPF_LOCAL_LIBRARY
  implicit none
  real, dimension (:,:) :: x
  !hpf$ inherit :: x
  !hpf$ range (block(),block()) :: x
  integer, dimension (7) :: lb, ub, stride, axis_map
  !hpf$   distribute (*) :: lb, ub, stride, axis_map
  logical :: identity_map, dinamico
  integer :: ncopias, i
  !
  lb = 0
  ub = 0
  stride = 0
  axis_map = 0
  call global_alignment (x, lb, ub, stride, axis_map,  &
                         identity_map, dinamico, ncopias)
  print 10, (lb(i), i=1,3)
  print 20, (ub(i), i=1,3)
  print 30, (stride(i), i=1,3)
  print 40, (axis_map(i), i=1,3)
  print 50, identity_map
  print 60, dinamico
  print 70, ncopias
  10   format ("LB       : ",7I5)
  20   format ("UB       : ",7I5)
  30   format ("STRIDE   : ",7I5)
  40   format ("AXIS_MAP : ",7I5)
  50   format ("IDENTITY : ",L5)
  60   format ("DYNAMIC  : ",L5)
  70   format ("NCOPIES  : ",I5)
end subroutine
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
