! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
!
! compilation with (adaptor + mpich):
!  adaptor -hpf -dm -free -o blocks.exe blocks.f90
!
! running with mpich:
!  mpdboot -n 21 -f ~/mpd.hosts
!  mpdtrace
!  mpiexec -machinefile ~/machi.dat -np 2 blocks.exe
!  mpdallexit
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program hpf_local_test
  implicit none  
  integer, parameter :: n = 100
  real, dimension (n,n) :: A
  !hpf$ distribute a(cyclic(5),cyclic(5))
  interface
    extrinsic (hpf_local) subroutine tarea (a)
    real, dimension (:,:) :: a   ! must be assumed shaped
    !hpf$ distribute a(cyclic (5),cyclic(5))
    end subroutine
  end interface
  print *, "nproc = ", number_of_processors ()
  call tarea (a)
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
extrinsic ("HPF","LOCAL") subroutine tarea (a)
  use HPF_LOCAL_LIBRARY
  implicit none
  real, dimension (:,:) ::  a
  !hpf$ distribute a(cyclic(5),cyclic(5))
  integer, dimension (2) :: blkcnt, lb
  integer, allocatable, dimension (:) :: lindex, uindex
  integer :: idim, p, np
  !
  blkcnt (1) = LOCAL_BLKCNT (A, dim=1)      
  blkcnt (2) = LOCAL_BLKCNT (A, dim=2)      
  print *, "local blkcnt (A) = ", blkcnt 
  print *, "local_blkcnt (A) = ", LOCAL_BLKCNT (A)
  np = number_of_processors () - 1
  do  p = 0, np
    blkcnt = LOCAL_BLKCNT (A, proc=p)
    print *, "local blocks on P = ", p, " : ", blkcnt
    do idim = 1, 2
      allocate (lindex(blkcnt(idim)), uindex(blkcnt(idim)))
      lindex = LOCAL_LINDEX (A, idim, p)
      uindex = LOCAL_UINDEX (A, idim, p)
      print 10, idim, lindex
      print 11, idim, uindex
      deallocate (uindex, lindex)
    end do
  end do
  10 format (" lindex (dim=",I1,") : ",15I4)
  11 format (" uindex (dim=",I1,") : ",15I4)
end subroutine
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
