! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
!
! compilation with (adaptor + mpich):
!  adaptor -hpf -dm -free -o distribution.exe distribution.f90
!
! running with mpich:
!  mpdboot -n 21 -f ~/mpd.hosts
!  mpdtrace
!  mpiexec -machinefile ~/machi.dat -np 2 distribution.exe
!  mpdallexit
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program lib_test
  implicit none
  real, dimension (10, 10) :: A
  integer :: I, J
  !hpf$ template, dimension (40,40) :: T
  !hpf$ align A(I,J) with T(1+3*I,2*J)
  !hpf$ distribute T(block,block)
  !
  print *, "DISTRIBUTION of A"
  call show_distribution (A)
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
extrinsic (hpf_local) subroutine show_distribution (x)
  use HPF_LOCAL_LIBRARY
  implicit none
  real, dimension (:,:) :: x
  !hpf$ inherit :: X
  !hpf$ range (block(),block()) :: x
  character (10), dimension (7) :: axis_tipo = " "
  integer, dimension (7) :: axis_info=0, forma
  integer :: rango, i
  !
  call global_distribution (x, axis_tipo, axis_info, rango, forma)
  print 10, (axis_tipo(i), i=1,2)
  print 20, (axis_info(i), i=1,2)
  print 40, rango
  print 30, (forma (I), I=1,rango)
  10  format (" AXIS_TYPE  : ",7A12)
  20  format (" AXIS_INFO  : ",7I5)
  30  format (" PROC_SHAPE : ",7I5)
  40  format (" PROC_RANK  : ",I5)
end subroutine
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
