! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
!
! compilation with (adaptor + mpich):
!  adaptor -hpf -dm -free -o local1.exe local1.f90
!
! running with mpich:
!  mpdboot -n 21 -f ~/mpd.hosts
!  mpdtrace
!  mpiexec -machinefile ~/machi.dat -np 2 local1.exe
!  mpdallexit
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program hpf_local_test
  implicit none
  integer, parameter :: n = 100
  real, dimension (n) :: a
  !hpf$ distribute a(block)
  interface
    extrinsic (hpf_local) subroutine tarea (a)
    real, dimension (:) :: a   ! must be assumed shaped
    !hpf$ distribute a (block)
    end subroutine
  end interface
  !
  print *, "nproc = ", number_of_processors ()
  call tarea (a)
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
extrinsic ("hpf","local") subroutine tarea (a)
  use HPF_LOCAL_LIBRARY
  implicit none
  real, dimension (:) :: a
  !hpf$ distribute a (block)
  integer :: id
  id = my_processor()
  print *, id, " has ", lbound (a), ubound (a)
  print *, id, " has local  ", size        (a,1), " elements"
  print *, id, " has global ", global_size (a,1), " elements"
end subroutine
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
