! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
!
! compilation with (adaptor + mpich):
!  adaptor -hpf -dm -free -o local_set.exe local_set.f90
!
! running with mpich:
!  mpdboot -n 21 -f ~/mpd.hosts
!  mpdtrace
!  mpiexec -machinefile ~/machi.dat -np 2 local_set.exe
!  mpdallexit
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program local_set 
  implicit none
  integer, parameter :: n = 30
  integer, dimension (n) :: a
  !hpf$ distribute (block) :: a
  interface
    extrinsic (hpf_local) subroutine tarea (a)
    integer, dimension (:) :: a
    !hpf$ distribute (cyclic(3)) :: a
    end subroutine
  end interface 
  !
  a = -1.0
  call tarea (a)
  print 10, a
  10 format ("a = ",10i4)
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
extrinsic (hpf_local) subroutine tarea (a)
  use HPF_LOCAL_LIBRARY
  implicit none
  integer, dimension (:) :: a
  !hpf$ distribute (cyclic(3)) :: a
  integer :: p 
  p = my_processor ()
  print *, "my processor = ", p
  a = p
end subroutine
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
