! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
!
! compilation with (adaptor + mpich):
!  adaptor -hpf -dm -free -o processors.exe processors.f90
!
! running with mpich:
!  mpdboot -n 21 -f ~/mpd.hosts
!  mpdtrace
!  mpiexec -machinefile ~/machi.dat -np 2 processors.exe
!  mpdallexit
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program hpf_local_test
  implicit none
  integer, parameter :: n = 100
  real, dimension (n,n) :: a
  !hpf$ distribute a(block,block)
  interface
    extrinsic (hpf_local) subroutine tarea (a)
    real, dimension (:,:) :: a   ! must be assumed shaped
    !hpf$ distribute a(block,block)
    end subroutine
  end interface
  !
  print *, "nproc = ", number_of_processors ()
  call tarea (a)
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
extrinsic ("hpf","local") subroutine tarea (a)
  use HPF_LOCAL_LIBRARY
  implicit none
  real   , dimension (:,:) :: a
  integer, dimension (7) :: indice, forma
  integer :: i, i1, i2, rango, np, p
  !hpf$ distribute a(block,block)
  !
  call global_distribution (a, PROCESSORS_RANK =rango, &
                               PROCESSORS_SHAPE=forma)
  print *, "processor rank  = ", rango
  print *, "processor shape = ", (forma(i),i=1,rango)
  !
  do i2 = 1, forma (2)
    indice (2) = i2
    do i1 = 1, forma (1)
      indice (1) = i1
      call abstract_to_physical (a, indice, p)
      print *, "abstract : ", (indice (i), i=1,rango), &
               " is physical ", p
     end do
  end do
  !
  np = number_of_processors()
  do  p = 0, (np - 1)
    call physical_to_abstract (a, p, indice)
    print *, "physical ", p, " is abstract : ", &
             (indice (i), i=1,rango)
  end do
end subroutine
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
