module m_realoca
public
contains
  function realoca_r1 (p, n1)               ! reallocate REAL
    real, dimension (:), pointer :: p, realoca_r1
    integer, intent (in) :: n1
    integer :: n1old, ier, m
    allocate (realoca_r1 (1:n1), stat = ier)
    if (ier .ne. 0) stop "error: realoca"
    if (.not. associated (p) ) return
    n1old = min (size (p), n1)
    realoca_r1 (1:n1old) = p (1:n1old)
    deallocate (p, stat = ier)
    if (ier .ne. 0) stop "error: dloca p"
  end function
end module
!
program realoca_test
  use m_realoca
  implicit none
  real, dimension (:), pointer :: p => null() 
  integer :: j, nel = 4
  !
  allocate (p(1:nel))
  p (1) = 7
  !
  print *
  print *, "alocado inicial = ", size (p), " elementos"
  print *, "p (1) = ", p (1)
  !
  p => realoca_r1 (p, 6)    ! note pointer assignment
  print *
  print *, "alocado actual  = ", size (p), " elementos"
  print *, "p (1) = ", p (1)
  !
  p => realoca_r1 (p, 8)    ! note pointer assignment
  print *
  print *, "alocado actual  = ", size (p), " elementos"
  print *, "p (1) = ", p (1)
  !
  p => realoca_r1 (p, 3)    ! note pointer assignment
  print *
  print *, "alocado actual  = ", size (p), " elementos"
  print *, "p (1) = ", p (1)
  !
  print *
end program

