! With Descriptive Mapping and F77 sintaxis in the align directive
module m_matriz2
  implicit none
  public
  contains
    subroutine bar (q,r)
      integer, dimension (:,:) :: q, r
      !hpf$ distribute q * (block,block)                
      !hpf$ align r (i,j) with * q (i,j)
      integer :: i, j, n
      n = size (r,1)    
      do  i = 1, n 
        do  j = 1, n 
          r (i,j) = (i - 1) * n + j
        end do
      end do
    end subroutine
end module
!
program foo2
  use m_matriz2
  implicit none
  integer, parameter :: n = 4
  integer :: i, j
  integer, dimension (n,n) :: t           
  integer, dimension (n,n) :: u  
  !hpf$ distribute t (block,block)
  !hpf$ align u (i,j) with t (i,j)
  call bar (t,u)
  print *
  print *, "with Descriptive Mapping ..."
  print *, "u "
  do  i = 1, n 
    print 10, u (i,:)
  end do
  print *
  print *, "fine ..."
  10 format (40(1x,i4))
end program             


