! With Descriptive Mapping and F90 sintaxis in the align directive
module m_matriz3
  implicit none
  public
  contains
    subroutine bar (q,r)
      integer, dimension (:,:) :: q, r
      !hpf$ distribute * (block,block) :: q
      !hpf$ align (i,j) with * q (i,j) :: r
      integer :: i, j, n
      n = size (r,1)    
      do  i = 1, n 
        do  j = 1, n 
          r (i,j) = (i - 1) * n + j
        end do
      end do
    end subroutine
end module
!
program foo3
  use m_matriz3
  implicit none
  integer, parameter :: n = 4
  integer :: i, j
  integer, dimension (n,n) :: t           
  integer, dimension (n,n) :: u  
  !hpf$ distribute t (block,block)
  !hpf$ align (i,j) with t (i,j) :: u 
  call bar (t,u)
  print *
  print *, "with Descriptive Mapping ..."
  print *, "u "
  do  i = 1, n 
    print 10, u (i,:)
  end do
  print *
  print *, "fine ..."
  10 format (40(1x,i4))
end program             


