! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
!  ifort -vms -o foo6.exe foo6.f90
!  g95 -o foo6.exe foo6.f90
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
module m_precision
  private
  public ip, sp, dp, qp
  implicit none
  integer, parameter :: ip = kind(1)
  integer, parameter :: sp = kind(1.0)
  integer, parameter :: dp = selected_real_kind(2*precision(1.0_sp))
  integer, parameter :: a  = selected_real_kind(2*precision(1.0_dp))
  integer, parameter :: qp = (1+sign(1,a))/2*a+(1-sign(1,a))/2*dp
end module
!
program foo6
  use m_precision
  !
  real (kind=dp) :: pi_dp
  real (kind=qp) :: pi_qp
  !
  pi_dp = 2.0_dp * asin (1.0_dp)
  pi_qp = 2.0_qp * asin (1.0_qp)
  !
  print *
  print *, "integer precision     ; ip = ", ip
  print *, "single real precision ; sp = ", sp
  print *, "double real precision ; dp = ", dp
  print *, "quadruple precision   ; qp = ", qp
  print *, "pi_dp = ", pi_dp
  print *, "pi_qp = ", pi_qp
  !
end program
! -----------------------------------------------------------------
