! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! Herramientas varias
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
module m_tools
 use   m_ctes
 use   m_globals
 implicit none
 private ! todo es privado excepto lo indicado
 !
 interface  errata
   module procedure  errata0, errata1, erratai, erratal
 end interface
 !
 interface  siza
   module procedure  siza2, siza3, siza4, sizav
 end interface
 !
 public  siza
 public  errata
 public  irandom_ne
 public  barajar
 public  irandom_ab1, irandom_ab2
 public  prog_arit_i, prog_arit_d
 public  scatter_add_i, scatter_add_d
 public  copia_arreglo_i, copia_arreglo_d
 !
 character (11), parameter :: f = "herramie_m> "
 !
 contains
 !
 subroutine errata0 (ley)
  character (*), intent (in) :: ley
  write (*,100) f
  write (*,100) f // "error " // ley
  stop
  100 format (a)
  stop
 end subroutine
 !
 subroutine errata1 (jer,ley)
  integer (iin), intent (in) :: jer
  character(*) , intent (in) :: ley
  write (*,100) f
  write (*,100) f // "error " // ley
  write (*,*) jer
  stop
  100 format (a)
 end subroutine
 !
 subroutine  erratai (jer,ley)
  integer (iin), dimension (:), intent (in) :: jer
  character (*)               , intent (in) :: ley
  integer (iin) :: n
  n = size (jer)
  write (*,100) f
  write (*,100) f // "error " // ley
  write (*,*) jer (1:n)
  stop
  100 format (a)
 end subroutine
 !
 subroutine  erratal (ber,ley)
  logical, dimension (:), intent (in) :: ber
  character (*)         , intent (in) :: ley
  write (*,100) f
  write (*,100) f // "error " // ley
  write (*,*) ber
  stop
  100 format (a)
 end subroutine
 !
 ! genera numero aleatorio entero "i" tal que a <= i < b
 ! En este esquema se genera primero un numero aleatorio
 ! real "r" en [0,1), luego se lo mapea al intervalo [a,b)
 ! y, finalmente, se toma i = piso (mapeo_ab(r))
 function irandom_ab1 (a, b)
  integer (iin), intent (in) :: a, b
  integer (iin) :: irandom_ab1
  integer (iin) :: i
  real    (idp) :: r, z
  call random_number (r)
  z = a + abs (b - a) * r
  i = floor (z)
  if (i > z)  i = i - 1
  irandom_ab1 = i
 end function
 !
 function irandom_ab2 (a, b, n)
  integer (iin), intent (in) :: a, b, n
  integer (iin), dimension (n) :: irandom_ab2
  real    (idp), dimension (n) :: r, z
  integer (iin), dimension (n) :: i
  irandom_ab2 = 0
  call random_number (r)
  z = a + abs (b - a) * r
  i = floor (z)
  where (i > z)  i = i - 1
  irandom_ab2 = i
 end function
 !
 ! devuelve dos numeros aleatorios distintos en [a,b)
 function irandom_ne (a, b)
  integer (iin), intent (in) :: a, b
  integer (iin), dimension (2) :: irandom_ne
  real    (idp), dimension (2) :: r, z
  integer (iin), dimension (2) :: i
  irandom_ne = 0
  do
   call random_number (r)
   z = a + abs (b - a) * r
   i = floor (z)
   where (i > z)  i = i - 1
   if ( i (1) .ne. i (2) ) exit
  end do
  irandom_ne = i
 end function
 !
 ! desordena aleatoriamente la sucesion [a:b]
 function barajar (a, b)
  integer (iin), intent (in) :: a, b
  integer (iin), dimension (b-a+1) :: barajar
  integer (iin), dimension (b-a+1) :: u, v
  integer (iin) :: h, i, j, k, n
  real    (idp) :: r, z
  u (1) = a
  n = (b - a) + 1
  do i = 2, n
   u (i) = u (i-1) + 1
  end do
  h = n
  do  k = 1, n
   call random_number (r)
   z = 1 + h * r
   i = floor (z)
   if (i > z)  i = i - 1
   v (k) = u (i)
   do  j = i, (n - 1)
    u (j) = u (j + 1)
   end do
   h = h - 1
  end do
  barajar = v
 end function
 !
 ! informa y fin si los enteros no son todos iguales
 function siza2 (n1, n2, s)
  integer (iin), intent (in) :: n1, n2
  character(*) , intent (in) :: s
  integer (iin) :: siza2
  if (n1 .eq. n2) then
   siza2 = n1
  else
   siza2 = 0
   write (*,*) "n1 n2 ", n1, n2
   write (*,100) " error (siza2): fallo en " // s
   stop
  end if
  if (n1 .lt. 0)  stop" error (siza2): n < 0 "
  100 format (a)
 end function
 !
 ! informa y fin si los enteros no son todos iguales
 function siza3 (n1, n2, n3, s)
  integer (iin), intent (in) :: n1, n2, n3
  character(*) , intent (in) :: s
  integer (iin) :: siza3
  if (n1 .eq. n2 .and. n2 .eq. n3) then
   siza3 = n1
  else
   siza3 = 0
   write (*,*)" n1 n2 n3 ", n1, n2, n3
   write (*,100) " error (siza3): fallo en " // s
   stop
  end if
  if (n1 .lt. 0)  stop" error (siza3): n < 0 "
  100 format (a)
 end function
 !
 ! informa y fin si los enteros no son todos iguales
 function siza4 (n1, n2, n3, n4, s)
  integer (iin), intent (in) :: n1, n2, n3, n4
  character(*) , intent (in) :: s
  integer (iin) :: siza4
  if (n1 .eq. n2 .and. n2 .eq. n3 .and. n3 .eq. n4) then
   siza4 = n1
  else
   siza4 = 0
   write (*,*)" n1 n2 n3 n4 ", n1, n2, n3, n4
   write (*,100) " error (siza4): fallo en " // s
   stop
  end if
  if (n1 .lt. 0)  stop" error (siza4): n < 0 "
  100 format (a)
 end function
 !
 ! informa y fin si los enteros no son todos iguales
 function sizav (ii, s)
  integer (iin), dimension (:), intent (in) :: ii
  character(*) , intent (in) :: s
  integer (iin) :: sizav
  if ( all ( ii .eq. ii (1) ) ) then
   sizav = ii (1)
  else
   sizav = 0 * ii (1)
   write (*,*)" ii ", ii
   write (*,100) " error (sizav): fallo en " // s
   stop
  end if
  if (ii (1) .lt. 0)  stop" error (sizav): n < 0 "
  100 format (a)
 end function
 !
 ! devuelve un vector de "n" elementos obtenidos como una progresion 
 ! aritmetica de valor inicial "v_ini" e incremento "dta_v" 
 function prog_arit_i (v_ini, dta_v, n) 
  integer (iin), intent (in) :: v_ini, dta_v
  integer (iin), intent (in) :: n
  integer (iin), dimension (n) :: prog_arit_i
  integer (iin) :: k
  if (n > 0) prog_arit_i (1) = v_ini
  forall (k=2:n) prog_arit_i (k) = v_ini + (k -1) * dta_v 
 end function
 function prog_arit_d (v_ini, dta_v, n) 
  real    (idp), intent (in) :: v_ini, dta_v
  integer (iin), intent (in) :: n
  real    (idp), dimension (n) :: prog_arit_d
  integer (iin) :: k
  if (n > 0) prog_arit_d (1) = v_ini
  forall (k=2:n) prog_arit_d (k) = v_ini + (k -1) * dta_v 
 end function
 !
 ! suma expandida: desde "a" hacia "b" en las posiciones destino "ib"
 ! en HPF esta "scatter_add" se la puede reemplazar por la funcion 
 ! de libreria "sum_scatter".
 subroutine scatter_add_i (b, a, ib)
  integer (iin), dimension (:), intent (out) :: b
  integer (iin), dimension (:), intent (in)  :: a
  integer (iin), dimension (:), intent (in)  :: ib  
  integer (iin) :: m, n, j, i
  n = siza2 (size (a), size (ib), "scatter_add")
  m = size (b)
  b = 0
  do  j = 1, n
   i = ib (j)                   ! indice destino
   if (i < 1 .or. i > m) cycle  ! esta fuera de rango 
   b (i) = b (i) + a (j) 
  end do
 end subroutine 
 subroutine scatter_add_d (b, a, ib)
  real    (idp), dimension (:), intent (out) :: b
  real    (idp), dimension (:), intent (in)  :: a
  integer (iin), dimension (:), intent (in)  :: ib  
  integer (iin) :: m, n, j, i
  n = siza2 (size (a), size (ib), "scatter_add")
  m = size (b)
  b = 0.0
  do  j = 1, n
   i = ib (j)                   ! indice destino
   if (i < 1 .or. i > m) cycle  ! esta fuera de rango 
   b (i) = b (i) + a (j) 
  end do
 end subroutine 
 !
 ! copia como salida "b" un arreglo dato "a", donde |b| <= |a|
 subroutine copia_arreglo_i (a, b, n_copiados, n_omitidos)
  integer (iin), dimension (:), intent (in)    :: a
  integer (iin), dimension (:), intent (inout) :: b
  integer (iin)               , intent (out)   :: n_copiados
  integer (iin)               , intent (out)   :: n_omitidos
  !hpf$ inherit :: b   !!! , distribute (cyclic) :: b 
  integer (iin) :: m, n, j, i
  n_copiados = min (size (a), size (b))
  n_omitidos = size (a) - n_copiados
  b (1:n_copiados) = a (1:n_copiados)
 end subroutine 
 !
 ! copia como salida "b" un arreglo dato "a", donde |b| <= |a|
 subroutine copia_arreglo_d (a, b, n_copiados, n_omitidos)
  real    (idp), dimension (:), intent (in)    :: a
  real    (idp), dimension (:), intent (inout) :: b
  integer (iin)               , intent (out)   :: n_copiados
  integer (iin)               , intent (out)   :: n_omitidos
  !hpf$ inherit :: b   !!!, distribute (cyclic) :: b 
  integer (iin) :: m, n, j, i
  n_copiados = min (size (a), size (b))
  n_omitidos = size (a) - n_copiados
  b (1:n_copiados) = a (1:n_copiados)
 end subroutine 
end module
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
