c23456789         
        program tera2
        implicit none
        integer, parameter :: idp = kind (1.0 d0)
        integer, parameter :: iin = kind (1)
        integer (iin), parameter :: kmax =   256
        integer (iin), parameter :: n    = 1 600
        real    (idp), parameter :: tol  = 1.0d-16
        integer (iin), dimension (3) :: itim1, itim2, itim3
        real    (idp), dimension (n,n), target  :: c
        real    (idp), dimension (:,:), pointer :: back, next
        real    (idp) :: r
        integer (iin) :: i, j, k
c ----------------------------------------------------------------
        write (*,*)
        write (*,*)' raiz cuadrada de un numero (c)  '
        write (*,*)' por iteracion                   '
        write (*,*)
        write (*,*)' x_{k+1} = ( x_k + c / x_k ) / 2 '
        write (*,*)
        write (*,*)' donde (x_k) es una estimacion   '
        write (*,*)' para k=1,2,... con x_0 = c      '
        write (*,*)
        write (*,*)' n     ', n
c ----------------------------------------------------------------
        do  100 i = 1, n
        do  100 j = 1, n
  100   c (i,j) = 1.0 / real (i+j)
c ----------------------------------------------------------------
        call  itime (itim1) ! hour minute second
c ----------------------------------------------------------------
        back => c
        k    =  0
        do
          next => itera (back, c)
          r = abs ( maxval (next - back) ) 
          if ( r .lt. tol .or. k .gt. kmax )  exit
          k = k + 1
          back => next
        end do
c ----------------------------------------------------------------
        call  itime (itim2) ! hour minute second
        if  ( itim2 (3) .lt. itim1 (3) )  then
           itim2 (3) = itim2 (3) + 60 
           itim2 (2) = itim2 (2) -  1
        end if
        if  ( itim2 (2) .lt. itim1 (2) )  then
           itim2 (2) = itim2 (2) + 60 
           itim2 (1) = itim2 (1) -  1
        end if
        itim3 = itim2 - itim1
        write (*,*)' k  ', k
        write (*,*)' r  ', r
        write (*,*)' t1 ', itim1
        write (*,*)' t2 ', itim2
        write (*,*)' dt ', itim3
c ----------------------------------------------------------------
        contains
c ----------------------------------------------------------------
        function  itera (x,c)
        implicit none
        integer, parameter :: idp = kind (1.0d0)
        integer, parameter :: iin = kind (1)
        real (idp), dimension (:,:), intent (in) :: x, c
        real (idp), dimension (:,:), pointer :: itera
        integer (iin) :: i, n, m
        n = size (x, dim = 1)
        m = size (x, dim = 2)
        allocate ( itera (n,m) )
        itera = 0.5 * (x + c / x)
        end function
c ----------------------------------------------------------------
        end program
c ----------------------------------------------------------------

