c ================================================================
        module consta
        implicit none
        integer   , parameter :: idp  = kind (1.0d0)
        integer   , parameter :: iin  = kind (1)

        real (idp), parameter :: cero = 0.0 d0
        real (idp), parameter :: uno  = 1.0 d0
        real (idp), parameter :: tol  = 1.0 d-15
        end module
c ================================================================
        program  mera5
        implicit none
        real (idp), dimension (n,n)          :: a
        real (idp), dimension (n)            :: b
        real (idp), dimension (:,:), pointer :: s
c ----------------------------------------------------------------
        call  itime (itim1) ! hour minute second
        s => gcs (a,b)
        call  time2 (itim1) ! hour minute second
c ----------------------------------------------------------------
        contains
c ================================================================
        function gcs (a, b)
        implicit none
        integer      , parameter :: idp = kind (1.0d0)
        integer      , parameter :: iin = kind (1)
        integer (iin), parameter :: imax = 128
        real (idp), dimension (:,:), intent (in) :: a
        real (idp), dimension (:)  , pointer     :: cgs
        real (idp), dimension (:)  , allocatable :: t, r0, r1, w0
        integer (iin) :: i, n
        n = size (b, dim = 1)
        allocate ( gcs (n) )
        cgs  = b
        t    = (a, cgs)
        r0   = b - t
        r1   = r0
        p1   = 0
        w0   = 0
        rho  = ( r0 , r1 ) 
        beta = rho
        do  i = 1, imax
          u     = r + w
          z     = w + beta * p
          p     = u + beta * z
          c     = Q * p
          v     = A * c
          gama  = ( r1 , v )
          alfa  = rho / gama
          w     = u - alfa * v
          y     = u + w
          c     = Q * y
          cgs   = cgs + alfa * c
          z     = (A , c)
          r     = r - alfa * z
          sigma = sqrt ( pmul (r,r) )
          if ( sigma < tol )  exit
          rho   = ( r1 , r )
          tau   = sqrt ( pmul (r,r) )
          if ( tau   < tol )  exit
          beta  = rho / rho
        end do
        end function
c ================================================================
        subroutine  time2 (itim1)
        call  itime (itim2) ! hour minute second
        if  ( itim2 (3) .lt. itim1 (3) )  then
           itim2 (3) = itim2 (3) + 60 
           itim2 (2) = itim2 (2) -  1
        end if
        if  ( itim2 (2) .lt. itim1 (2) )  then
           itim2 (2) = itim2 (2) + 60 
           itim2 (1) = itim2 (1) -  1
        end if
        itim3 = itim2 - itim1
        write (*,*)' t1 ', itim1
        write (*,*)' t2 ', itim2
        write (*,*)' dt ', itim3
        end subroutine
        end program
c ================================================================
