! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! Matrices ralas: formato (i,j,a_ij). 
! Producto y=Ax con scatter HPF
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
!
! GNU:   
! ***
!
! PGI (HPF):   
! pghpf -V -Minfo -Mmpi -fast -c rala_csa.f90
! pghpf -V -Minfo -Mmpi -fast -o rala_csa.exe rala_csa.o
! mpirun -machinefile machi.dat -np 1 rala_csa.exe
!
! ADAPTOR (HPF)
! compilation for Distributed Memory Machines using MPI:
! adaptor -hpf -dm -free -c rala_csa.f90
! adaptor -hpf -dm -o rala_csa.exe rala_csa.o
! mpirun -machinefile machi.dat -np 1 rala_csa.exe
!
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program rala_csa
  use hpf_library
  implicit none
  integer, parameter :: n = 4, p = 7
  integer, dimension (n) :: x, y
  integer, dimension (p) :: a, i, j
  !hpf$ distribute (block)   :: a
  !hpf$ align (:) with a (:) :: i, j
  !hpf$ align (:) with a (:) :: x, y
  !
  write (*,*)
  write (*,*) "Matrices ralas: formato (i,j,a_ij) "
  write (*,*) "producto y=Ax con scatter HPF"
  !
  i = (/ 1, 4, 6, 2, 3, 1, 3, 5, 4, 2, 5, 7, 3, 6, 7, 5, 7 /)
  j = (/ 1, 1, 1, 2, 2, 3, 3, 3, 4, 5, 5, 5, 6, 6, 6, 7, 7 /)
  a = (/ 1, 2, 3, 4, 5, 6, 7, 8, 9, 1, 2, 3, 4, 5, 6, 7, 8 /) 
  !
  x = (/ 1, 2, 3, 4 /)
  b = a * x (j)
  y (1:n) = sum_scatter (b (1:p), y (1:n), i (1:p) )
  write (*,*)
  write (*,100)" i        : ", i
  write (*,100)" j        : ", j
  write (*,100)" a        : ", a
  write (*,100)" b        : ", b
  write (*,*)
  write (*,100)" x        : ", x
  write (*,100)"     x(j) : ", x (j)
  write (*,100)" a * x(j) : ", b
  write (*,100)" y        : ", y
  write (*,*)
  100 format (a, 10 (1x,i6))
end program 
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
