! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! Matriz rala en formato [i j a_ij ]
! . Lectura de una matriz rala
! . Define un Sistema de Ecuaciones Algebraicas Ralo (SEAR)
! . Resuelve iterativamente un SEAR por CGS
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! GNU:
! g95 -w -c ctes.f90 --free-form
! g95 -w -c temps.f90 --free-form
! g95 -w -c globals.f90 --free-form
! g95 -w -c tools1.f90 --free-form
! g95 -w -c ral_fila1.f90 --free-form
! g95 -w -c ensa1.f90 --free-form
! g95 -w -o ensa1.exe ctes.o temps.o tools1.o ral_fila1.o ensa1.o
! ensa1.exe
!
! PGI (F95):   
! pgf90 -V -Minfo -fast -c ctes.f90
! pgf90 -V -Minfo -fast -c temps.f90
! pgf90 -V -Minfo -fast -c globals.f90
! pgf90 -V -Minfo -fast -c tools1.f90
! pgf90 -V -Minfo -fast -c ral_fila1.f90
! pgf90 -V -Minfo -fast -c ensa1.f90
! pgf90 -V -Minfo -fast -o ensa1.exe 
!  ctes.o temps.o globals.o tools1.o ral_fila1.o ensa1.o
! ensa1.exe
!
! PGI (HPF+MPI):   
! pghpf -V -Minfo -Mmpi -fast -c ctes.f90
! pghpf -V -Minfo -Mmpi -fast -c temps.f90
! pghpf -V -Minfo -Mmpi -fast -c globals.f90
! pghpf -V -Minfo -Mmpi -fast -c tools1.f90
! pghpf -V -Minfo -Mmpi -fast -c ral_fila1.f90
! pghpf -V -Minfo -Mmpi -fast -c ensa1.f90
! pghpf -V -Minfo -Mmpi -fast -o ensa1.exe 
!   ctes.o temps.o globals.o tools1.o ral_fila1.o ensa1.o
!
! mpirun -machinefile machi.dat -np 1 ensa1.exe
! mpirun -machinefile machi.dat -nolocal -np 1 ensa1.exe
! mpirun -machinefile machi.dat -nolocal -np 2 ensa1.exe
! mpirun -machinefile machi.dat -nolocal -np 4 ensa1.exe
!
! PGI (HPF):
! pghpf -V -Minfo -fast -c ctes.f90
! pghpf -V -Minfo -fast -c temps.f90
! pghpf -V -Minfo -fast -c globals.f90
! pghpf -V -Minfo -fast -c tools1.f90
! pghpf -V -Minfo -fast -c ral_fila1.f90
! pghpf -V -Minfo -fast -c ensa1.f90
! pghpf -V -Minfo -fast -o ensa1.exe 
!   ctes.o temps.o globals.o tools1.o ral_fila1.o ensa1.o
! ensa1.exe -pghpf -host -file=machi.hpf, -v -np 1 -stat > p.log &
!
! PGI (HPF) + PROFILER:  
! pghpf -V -Minfo -fast -Mprof=lines -c ctes.f90
! pghpf -V -Minfo -fast -Mprof=lines -c temps.f90
! pghpf -V -Minfo -fast -Mprof=lines -c globals.f90
! pghpf -V -Minfo -fast -Mprof=lines -c tools1.f90
! pghpf -V -Minfo -fast -Mprof=lines -c ral_fila1.f90
! pghpf -V -Minfo -fast -Mprof=lines -c ensa1.f90
! pghpf -V -Minfo -fast -Mprof=lines -o ensa1.exe 
!   ctes.o temps.o globals.o tools1.o ral_fila1.o ensa1.o
! ensa1.exe -pghpf -host -file=machi.hpf, -v -np 1 -stat > p.log &
!
! PGI (F95) + PROFILER:   
! pgf90 -V -Minfo -fast -Mprof=lines -c ctes.f90
! pgf90 -V -Minfo -fast -Mprof=lines -c temps.f90
! pgf90 -V -Minfo -fast -Mprof=lines -c globals.f90
! pgf90 -V -Minfo -fast -Mprof=lines -c tools1.f90
! pgf90 -V -Minfo -fast -Mprof=lines -c ral_fila1.f90
! pgf90 -V -Minfo -fast -Mprof=lines -c ensa1.f90
! pgf90 -V -Minfo -fast -Mprof=lines -o ensa1.exe //
!   ctes.o temps.o tools1.o ral_fila1.o ensa1.o
! correr un caso ensa chico --> deberia generar el "pgprof.out"
! pgprof -s pgprof.out      --> usra print
!
! PGI (HPF+MPI+PROFILER):   
! pghpf -V -Minfo -Mmpi -fast -Mprof=lines -c ctes.f90
! pghpf -V -Minfo -Mmpi -fast -Mprof=lines -c temps.f90
! pghpf -V -Minfo -Mmpi -fast -Mprof=lines -c globals.f90
! pghpf -V -Minfo -Mmpi -fast -Mprof=lines -c tools1.f90
! pghpf -V -Minfo -Mmpi -fast -Mprof=lines -c ral_fila1.f90
! pghpf -V -Minfo -Mmpi -fast -Mprof=lines -c ensa1.f90
! pghpf -V -Minfo -Mmpi -fast -Mprof=lines -o ensa1.exe //
!   ctes.o temps. globals.o tools1.o ral_fila1.o ensa1.o
!
! ADAPTOR for Distributed Memory Machines using MPI:
! adaptor -hpf -dm -free -c ctes.f90
! adaptor -hpf -dm -free -c temps.f90
! adaptor -hpf -dm -free -c globals.f90
! adaptor -hpf -dm -free -c tools1.f90
! adaptor -hpf -dm -free -c sea_rala.f90
! adaptor -hpf -dm -free -c ensa1.f90
! adaptor -hpf -dm -o ensa1.exe 
!   ctes.o temps.o globals.o tools1.o sea_rala.o ensa1.o
! mpirun -machinefile machi.dat -np 1 ensa1.exe
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program ensa1
 use ctes
 use globals
 use tools1
 use ral_fila1
 implicit none
 character(13), parameter :: f = 'rala_fila1:> '
 type (ralo_t) :: sa 
 integer (iin), dimension   (:), allocatable :: ifila
 integer (iin), dimension   (:), allocatable :: jcolu
 real    (idp), dimension   (:), allocatable :: valor
 real    (idp), dimension (:,:), allocatable :: b
 !hpf$ distribute (cyclic) :: ifila
 !hpf$ align jcolu (:) with ifila (:)
 !hpf$ align valor (:) with ifila (:)
 character (10) :: arch
 integer  (iin) :: nit
 real     (idp) :: rum
 integer  (iin) :: m, n, p
 integer  (iin) :: kaso
 !
 ! en disco: matriz triangular superior incluida diag ppal
 arch = "rala1"
 call parametros_sea (sa, nit, rum, kaso)
 n = sa % n  ;  p = sa % p  ;  m = sa % m
 !
 ! aloca
 ier = 0
 allocate ( ifila (p), stat = ier (1) )
 allocate ( jcolu (p), stat = ier (2) )
 allocate ( valor (p), stat = ier (3) )
 allocate (   b (m,n), stat = ier (4) )
 if ( any (ier .ne. 0) ) call errata (ier(1:4), "aloca")
 !
 select case (kaso)
 case (1)
   call  random_sea (sa, ifila, jcolu, valor, b)
 case (2)
   call  lect_rala1 (sa, ifila, jcolu, valor, b)
 case (3)
   call  tridia_sea (sa, ifila, jcolu, valor, b)
 case default
   call  errata (kaso, "kaso erroneo")
 end select
 !
 ! resuelve
 !call eco_toda (sa, ifila, jcolu, valor)
 !call eco_diag (sa, ifila, jcolu, valor)
 !
 ! tarea
 call cgs_rala (sa, ifila, jcolu, valor, b, nit, rum)
 !
 ! dloca
 ier = 0
 deallocate ( ifila, stat = ier (1) )
 deallocate ( jcolu, stat = ier (2) )
 deallocate ( valor, stat = ier (3) )
 deallocate (     b, stat = ier (4) )
 if ( any (ier .ne. 0) ) call errata (ier(1:4), "dloca")
 !
 contains
 !
 ! lee parametros SEALR
 subroutine parametros_sea (sa, nit, rum, kaso)
  type (ralo_t), intent (out) :: sa 
  integer (iin), intent (out) :: nit
  real    (idp), intent (out) :: rum
  integer (iin), intent (out) :: kaso
  !
  character (16):: lee_o_genera  
  character (16):: raiz_archivo
  integer (iin) :: nro_max_iteraciones
  real    (idp) :: tolerancia_residuo
  !
  integer (iin) :: nro_de_incognitas
  integer (iin) :: nro_de_cargas
  !
  integer (iin) :: n, m, p
  integer (iin) :: n1, n2
  logical       :: alto
  character (16):: raiz, tarea
  !
  namelist  /sea_tarea/ lee_o_genera,        &
                        raiz_archivo,        &
                        nro_max_iteraciones, & 
                        tolerancia_residuo
  namelist  /sea_data/ nro_de_incognitas,    &
                       nro_de_cargas
  write (*,100) f
  write (*,100) f // "Sistema de Ecuaciones Algebraicas Ralo (SEAR) "
  write (*,100) f // "Resolucion iterativa por CGS "
  write (*,100) f
  write (*,100) f // "lee parametros de la corrida en el disco ... "
  !
  alto = .true.
  !
  open  (1, file = "rala.dat", status = "old", err = 600)
  read  (1, nml = sea_tarea, err = 610)
  close (1, status = 'keep')
  !
  nit   = nro_max_iteraciones    
  rum   = tolerancia_residuo 
  raiz  = raiz_archivo
  tarea = lee_o_genera
  !
  if     (tarea .eq. "genera") then
    kaso = 1
    open  (1, file = "rala.dat", status = "old", err = 600)
    read  (1, nml = sea_data, err = 610)
    close (1, status = 'keep')
    !
    n = nro_de_incognitas
    m = nro_de_cargas
    !
    n1 = n
    n2 = n * n + 1
    p  = irandom_ab (n1, n2)
    !
    sa % n = n
    sa % m = m
    sa % p = p
  elseif (tarea .eq. "lee") then
    kaso = 2
    call prelee_rala1 (raiz, sa)
  elseif (tarea .eq. "tridiagonal") then
    kaso = 3
    open  (1, file = "rala.dat", status = "old", err = 600)
    read  (1, nml = sea_data, err = 610)
    close (1, status = 'keep')
    !
    n = nro_de_incognitas
    m = nro_de_cargas
    p = n + 2 * (n - 1)
    !
    sa % n = n
    sa % m = m
    sa % p = p
  end if
  sa % nit  = nit
  sa % rum  = rum
  sa % raiz = raiz
  !
  write (*,100) f
  write (*,110) f // "caso                  ; kaso = ", kaso
  write (*,110) f // "nro de incognitas     ;    n = ", sa % n
  write (*,110) f // "nro de cargas         ;    m = ", sa % m
  write (*,110) f // "nro de elementos ralos;    p = ", sa % p
  write (*,110) f // "nro maximo de iterac. ;  nit = ", sa % nit
  write (*,120) f // "tolerancia            ;  rum = ", sa % rum
  write (*,100) f // "raiz archivos         ; raiz = " // sa % raiz
  !
  alto = .false.
  600 if (alto)  call  errata ("apertura *.dat")
  610 if (alto)  call  errata ("lectura  *.dat")
  !
  ! formatos
  100 format (a)
  110 format (a, 2 (i8), e24.12)
  120 format (a,         e24.12)
  300 format ( 2 (1x, i8), 1x, e24.16 )
  !
 end subroutine
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
