! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! GNU:   
! g95 -w -c proble01.f90 --free-form
! g95 -w -o proble01.exe proble01.o
! proble01.exe
!
! PGI, F90:   
! pgf90 -V -Minfo -fast -c tools.f90
! pgf90 -V -Minfo -fast -c sea_rala.f90
! pgf90 -V -Minfo -fast -c test1.f90
! pgf90 -V -Minfo -fast -o test1.exe tools.o sea_rala.o test1.o
!
! PGI, HPF:   
! pghpf -V -Minfo -fast -c tools.f90
! pghpf -V -Minfo -fast -c sea_rala.f90
! pghpf -V -Minfo -fast -c test1.f90
! pghpf -V -Minfo -fast -o test1.exe tools.o sea_rala.o test1.o
! mpirun -machinefile machi.dat -np 1 proble01.exe
!
! ADAPTOR for Distributed Memory Machines using MPI:
! adaptor -hpf -dm -free -c tools.f90
! adaptor -hpf -dm -free -c sea_rala.f90
! adaptor -hpf -dm -free -c test1.f90
! adaptor -hpf -dm -o test01.exe tools.o sea_rala.o test1.o
! mpirun -machinefile machi.dat -np 1 proble01.exe
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program test1
 use tools
 use sea_rala1
 implicit none
 type (ralo_t) :: sa 
 integer, parameter :: nit = 128
 real   , parameter :: rum = 1.0d-12
 real, dimension (:,:), allocatable :: b
 character (10) :: arch
 integer :: m, n, p
 integer :: i
 !
 ! en disco: matriz triangular superior incluida diag ppal
 arch = "rala1"
 call prelee_sea2 (arch, n, m, p)
 allocate ( sa % ifila (p), stat = ier (1) )
 allocate ( sa % jcolu (p), stat = ier (2) )
 allocate ( sa % valor (p), stat = ier (3) )
 allocate ( b (m,n)       , stat = ier (4) )
 if ( any (ier .ne. 0) ) call errata (ier, "tarea")
 call lee_sea2 (n, m, p, sa, b)
 !
 ! resuelve
 call eco_rala_toda (sa)
 call eco_rala_diag (sa)
 !
 call cgs_rala (sa, b, nit, rum)
 !
 contains
 !
 ! prelectura asumiendo que en disco se tiene TODA la matriz rala
 subroutine prelee_sea1 (raiz, n, m, p)
  character (*), intent (in)  :: raiz
  integer      , intent (out) :: n
  integer      , intent (out) :: m
  integer      , intent (out) :: p
  character (len(raiz)+7) :: arch1, arch2
  integer :: k1, k2
  integer :: l1, l2
  integer :: n1, n2, ll
  integer :: ii, jj, kk
  real    :: rr
  !
  ll = len_trim (raiz)
  arch1 = raiz (1:ll) // "_a.dat"
  arch2 = raiz (1:ll) // "_b.dat"
  write (*,*)
  write (*,*) "prelectura asumiendo que en disco se tiene "
  write (*,*) "TODA la matriz rala "
  write (*,*)
  write (*,*) "archivo matriz: " // arch1
  write (*,*) "        carga : " // arch2
  !
  open (1, file = arch1, status = "unknown")
  l1 = 0
  n1  = 0
  itera1: do
   read (1,*,end=10) ii, jj, rr
   if (ii > n1)  n1 = ii
   if (jj > n1)  n1 = jj
   l1 = l1 + 1
  end do itera1
  10 rewind (1)
  !
  open (2, file = arch2, status = "unknown")
  l2 = 0
  n2 = 0
  k2 = 0
  itera2: do
   read (2,*,end=20) ii, kk, rr
   if (ii > n2) n2 = ii
   if (kk > k2) k2 = kk
   l2 = l2 + 1
  end do itera2
  20 rewind (2)
  !
  n = siza (n1,n2, "prelee_sea")
  p = l1
  m = k2
  if ( (n * m) .ne. l2 ) call errata ("no sincroniza")
  !
  write (*,*)
  write (*,*)'nro de incognitas   ; n   = ', n
  write (*,*)'nro de cargas       ; m   = ', m
  write (*,*)'nro de elementos    ; p = ', p
 end subroutine
 !
 ! lectura asumiendo que en disco se tiene TODA la matriz rala
 subroutine lee_sea1 (n, m, p, sa, b)
  integer      , intent (in)  :: n
  integer      , intent (in)  :: m
  integer      , intent (in)  :: p
  type (ralo_t), intent (out) :: sa 
  real, dimension (:,:), intent (out) :: b
  integer :: k, l, nlineas
  integer :: ii, jj, kk
  real    :: rr
  sa % n = n
  sa % p = p
  write (*,*)
  write (*,*) "lectura asumiendo que en disco se tiene "
  write (*,*) "TODA la matriz rala "
  write (*,*)
  write (*,*) "matriz rala"
  do  k = 1, p
   read  (1,*) ii, jj, rr
   write (*,*) ii, jj, rr
   sa % ifila (k) = ii
   sa % ifila (k) = jj
   sa % valor (k) = rr
  end do
  write (*,*)
  write (*,*) "matriz de cargas"
  nlineas = m * n
  do  l = 1, nlineas
   read  (2,*) ii, kk, rr
   write (*,*) ii, kk, rr
   b (kk,ii) = rr
  end do
  close (1,status = "keep")
  close (2,status = "keep")
  stop
 end subroutine
 !
 ! prelectura asumiendo que en disco es TRIANG SUP + DIAG
 subroutine prelee_sea2 (raiz, n, m, p)
  character (*), intent (in)  :: raiz
  integer      , intent (out) :: n
  integer      , intent (out) :: m
  integer      , intent (out) :: p
  character (len(raiz)+7) :: arch1, arch2
  integer :: k1, k2
  integer :: l1, l2
  integer :: n1, n2, ll
  integer :: ii, jj, kk
  real    :: rr
  !
  ll = len_trim (raiz)
  arch1 = raiz (1:ll) // "_a.dat"
  arch2 = raiz (1:ll) // "_b.dat"
  write (*,*)
  write (*,*) "se asume que la matriz rala en disco es solo   "
  write (*,*) "triangular superior incluida diagonal principal"
  write (*,*)
  write (*,*) "archivo matriz: " // arch1
  write (*,*) "        carga : " // arch2
  !
  open (1, file = arch1, status = "unknown")
  l1 = 0
  n1  = 0
  itera1: do
   read (1,*,end=10) ii, jj, rr
   if (ii > n1)  n1 = ii
   if (jj > n1)  n1 = jj
   l1 = l1 + 1
  end do itera1
  10 rewind (1)
  !
  open (2, file = arch2, status = "unknown")
  l2 = 0
  n2 = 0
  k2 = 0
  itera2: do
   read (2,*,end=20) ii, kk, rr
   if (ii > n2) n2 = ii
   if (kk > k2) k2 = kk
   l2 = l2 + 1
  end do itera2
  20 rewind (2)
  !
  n = siza (n1,n2, "prelee_sea")
  p = 2 * (l1 - n) + n ! los elementos que deben quedar
  m = k2
  if ( (n * m) .ne. l2 ) call errata ("no sincroniza")
  !
  write (*,*)
  write (*,*)'nro de incognitas   ; n   = ', n
  write (*,*)'nro de cargas       ; m   = ', m
  write (*,*)'nro de elementos    ; p = ', p
 end subroutine
 !
 ! lectura asumiendo que en disco se tiene TRIAG SUP + DIAG
 subroutine lee_sea2 (n, m, p, sa, b)
  integer      , intent (in)  :: n
  integer      , intent (in)  :: m
  integer      , intent (in)  :: p
  type (ralo_t), intent (out) :: sa 
  real, dimension (:,:), intent (out) :: b
  integer :: k, l
  integer :: nlineas, pmitad
  integer :: ii, jj, kk
  real    :: rr
  sa % n = n
  sa % p = p
  write (*,*)
  write (*,*) "lectura asumiendo que en disco se tiene la "
  write (*,*) "parte TRIAG SUP + DIAG de la matriz rala   "
  write (*,*)
  write (*,*) "lee matriz rala, completando la parte TRIA INF"
  k = 0
  pmitad = (p - n) / 2 + n
  do  l = 1, pmitad
   read  (1,*) ii, jj, rr
   write (*,*) ii, jj, rr
   k = k + 1
   sa % ifila (k) = ii
   sa % jcolu (k) = jj
   sa % valor (k) = rr
   if (ii .eq. jj) cycle
   k = k + 1
   if (k > p) call errata ("p > p")
   write (*,*) jj, ii, rr
   sa % ifila (k) = jj
   sa % jcolu (k) = ii
   sa % valor (k) = rr
  end do
  write (*,*)
  write (*,*) "nro de incognitas   ;      n = ", n
  write (*,*) "nro de cargas       ;      m = ", m
  write (*,*) "nro de coeficientes ;      p = ", p
  write (*,*) "nro de lineas leidas; pmitad = ", pmitad
  write (*,*) "ultimo coefic asigna;      k = ", k
  !
  write (*,*)
  write (*,*) "matriz de cargas"
  nlineas = m * n
  do  l = 1, nlineas
   read  (2,*) ii, kk, rr
   write (*,*) ii, kk, rr
   if (ii < 1 .or. ii > n) call errata ("ii < 1 .or. ii > n")
   if (kk < 1 .or. kk > m) call errata ("kk < 1 .or. kk > m")
   b (kk,ii) = rr
  end do
  close (1,status = "keep")
  close (2,status = "keep")
 end subroutine
 !
end program
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
