! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
! Arreglos de 1 indice, intrinseca "sum_scatter" en HPF
!
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
!
! GNU:   
! ***
!
! PGI (HPF):   
! pghpf -V -Minfo -Mmpi -fast -c scatter2.f90
! pghpf -V -Minfo -Mmpi -fast -o scatter2.exe scatter2.o
! mpirun -machinefile machi.dat -np 1 scatter2.exe
!
! ADAPTOR (HPF)
! compilation for Distributed Memory Machines using MPI:
! adaptor -hpf -dm -free -c scatter2.f90
! adaptor -hpf -dm -o scatter2.exe scatter2.o
! mpirun -machinefile machi.dat -np 1 scatter2.exe
!
! -----+-----+-----+-----+-----+-----+-----+-----+-----+-----+-----
program scatter2
  use hpf_library
  implicit none
  logical, parameter :: T = .true.
  logical, parameter :: F = .false.
  !
  integer, parameter :: p = 6
  integer, dimension (p) :: a = 1, b = 2, c
  integer, dimension (p) :: i = (/ 1, 2, 2, 3, 3, 3 /)
  integer :: n
  !
  n = maxval (i)
  write (*,*)
  write (*,*) "Arreglos de 1 indice, intrinseca sum_scatter en HPF"
  write (*,*)
  write (*,110) " a : ", a
  write (*,110) " b : ", b
  write (*,110) " i : ", i
  write (*,110) " p : ", p
  !
  c (1:n) = sum_scatter (a (1:p), b (1:n), i (1:p))
  write (*,*)
  write (*,100) "c = sum_scatter (a, b, i): "
  write (*,110) "c : ", c (1:n)
  !
  c (1:n) = sum_scatter (b (1:p), a (1:n), i (1:p))
  write (*,*)
  write (*,100) "c = sum_scatter (b, a, i): "
  write (*,110) "c : ", c (1:n)
  !
  write (*,*)
  100 format (a)
  110 format (a, 10 (1x,i6))
  120 format (a, 10 (1x,l6))
end program 
! -------------------------------------------------------------------
