// in general the optimizing Fortran compiler may cause problems ..
// !! .. when data which is supposed to be received by asynchronous transfers
// !! .. is kept in registers.
// !! .. A common trick is to call MPI_Get_address before the received value
// !! .. is used.*/
// program fortranproblem

#include<iostream>
using namespace std;

#include"mpi++.h"

int main(int argc, char** argv)
{
     int          myrank, nprocs, n, i, islave, master=0, count;
     MPI::Win      win;
     MPI_Status   status;
     int          ierr, resultlen, tag;
     MPI::Aint     address;
     char         hostname[MPI_MAX_PROCESSOR_NAME];
     double       t0, t1, t2, fh;
     double	  fi;
     /* why do we need this ?
     double       PI25DP = 3.141592653589793238462643;
     double       mypi;
     double       f, a, h, x, pi, sum;*/
   
     // Initialize MPI
     MPI::Init(argc, argv);

     // Get my rank id and number of MPI processes
     myrank = MPI::COMM_WORLD.Get_rank();
     nprocs = MPI::COMM_WORLD.Get_size();

     // Get hostname
     MPI::Get_processor_name(hostname, resultlen);
     cout << "Rank " << myrank << " out of " << nprocs << " processes running on " << hostname << endl;

     // Synchronization point (not really necessary here)
     t0 = MPI::Wtime();
     MPI::COMM_WORLD.Barrier();
     t1 = MPI::Wtime();

  //!-----------------------------------------------------------
  //! Do work here ...
  while (true)
  {
    if (myrank == master)
    {
      win =win.Create(&fi, 8, 8, 0, MPI::COMM_WORLD);
      fi = 999.0;
      win.Fence(0);
      win.Fence(0);
      cout << fi << endl;
      if (fi != 777.0)
	MPI::COMM_WORLD.Abort(99);
         
    }
    else
    {
      fh = 777.0;
      win = win.Create(&fi, 0, 8, 0, MPI::COMM_WORLD);
      win.Fence(0);
      win.Put(&fh, 1, MPI::DOUBLE, master, 0, 1, MPI::DOUBLE);
      win.Fence(0);
    }
    win.Free();

    if (myrank == master)
    {
      win = win.Create(&fi, 8, 8, 0, MPI::COMM_WORLD);
      fi = 999.0;
      win.Fence(0);
      win.Fence(0);
      address = MPI::Get_address(&fi);
      cout << fi << endl;
    }
    else
    {
      fh = 777.0;
      win = win.Create(&fi, 0, 8, 0, MPI::COMM_WORLD);
      win.Fence(0);
      win.Put(&fh, 1, MPI::DOUBLE, master, 0, 1, MPI::DOUBLE);
      win.Fence(0);
    }
    win.Free();
  }
  //------------------------------------------------------------

  // Synchronization point (not really necessary here)
  MPI::COMM_WORLD.Barrier();
  t2 = MPI::Wtime();
  cout << "process " << myrank << " : " << t2-t1 << " seconds" << endl;

  // Shut Down MPI
  MPI::Finalize();

//end program fortranproblem
}
