// basic MPI program skeleton with
// MPI::Init, MPI::Comm::Get_rank, MPI::Comm::Get_size
// MPI::Get_processor_name, MPI::Barrier, MPI::Wtime
// MPI::Finalize

// program hello

#include<iostream>
using namespace std;
#include"mpi++.h"

int main(int argc,char* argv[])
{
     int          myrank, nprocs;
     int          resultlen;
     char         hostname[MPI_MAX_PROCESSOR_NAME];
     double       t1, t2;

     // Initialize MPI
     MPI::Init(argc, argv);

     // Get my rank id and number of MPI processes
     myrank = MPI::COMM_WORLD.Get_rank();
     nprocs = MPI::COMM_WORLD.Get_size();

     // Get hostname
     MPI::Get_processor_name(hostname, resultlen);

     // Synchonization point
     MPI::COMM_WORLD.Barrier();

     // measure runtime
     t1 = MPI::Wtime();

     //-----------------------------------------------------------
     // Do work here ...
     cout << "Hello! --- Rank " << myrank << " out of " << nprocs << " running on " << hostname << endl;
     //-----------------------------------------------------------

     // Synchronization point
     MPI::COMM_WORLD.Barrier();
     // measure runtime
     t2 = MPI::Wtime();
     cout << "slave " << myrank << " : " << t2-t1 << " seconds" << endl;

     // Shut Down MPI
     MPI::Finalize();
     return 0;
}
