// sending counterrotating messages in a ring using asynchronous transfers..
// .. MPI_Isend, MPI_Irecv
// prrogram asynchronous

#include<stdio.h>
#include<stdlib.h>
#include"mpi.h"
#define TRUE 1

int	main(int  argc,char** argv)
{
     int          myrank, nprocs, n, i, islave, master=0, count;
     MPI_Status   status[4];
     int          ierr, resultlen, ltag, rtag, ix;
     MPI_Request  reqid[4];
     int          left, right;
     char         hostname[MPI_MAX_PROCESSOR_NAME];
     double       t0, t1, t2;
     char	  *rsbytes, *lsbytes, *rrbytes, *lrbytes, *lbytes, *rbytes ;
     // character (LEN=1), allocatable, dimension(:) :: rsbytes, lsbytes, rrbytes, lrbytes, lbytes, rbytes

     // Initialize MPI
     MPI_Init(&argc, &argv);

     // Get my rank id and number of MPI processes
     MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
     MPI_Comm_size(MPI_COMM_WORLD, &nprocs);

     t0 = MPI_Wtime() ;

  //!-----------------------------------------------------------
  //! Do work here ...


  left  = (nprocs + myrank - 1) % nprocs;
  right =  (myrank + 1) % nprocs;
  rtag = 23;
  ltag = 24;
  printf("myrank= %d left neighbor= %d rigth neighbor= %d\n", myrank,left,right);
  TRUE=1;master=0;
  MPI_Barrier ( MPI_COMM_WORLD );

  while(TRUE)
  {
    // The master reads an integer number form standard input and sends it to all slaves
    if ( myrank == master )
    { //----------------------- Master part-----------------------------------
      printf("Number of bytes ? (0 quits, max %d = 128MB\n",1024*1024*128);
      //fflush(stdout);
      scanf("%d",&n);
    }

    MPI_Bcast ( &n, 1, MPI_INT, master, MPI_COMM_WORLD);
    if ((n <= 0) || (n > 1024*1024*128 ))
	break;

    if (myrank == master )
    { //-------------- Master part -------------------------------------------

      lsbytes = (char *) calloc(n,sizeof(char)) ;
      rsbytes = (char *) calloc(n,sizeof(char)) ;
      lrbytes = (char *) calloc(n,sizeof(char)) ;
      rrbytes = (char *) calloc(n,sizeof(char)) ;

      for(i=0;i<n;i++)
      {
      	lsbytes[i] = 'L';
      	rsbytes[i] = 'R';
      	lrbytes[i] = ' ';
      	rrbytes[i] = ' ';
      }

      t1 = MPI_Wtime() ;
      MPI_Isend ( lsbytes, n, MPI_BYTE, left, ltag, MPI_COMM_WORLD, reqid);
      MPI_Isend ( rsbytes, n, MPI_BYTE, right, rtag, MPI_COMM_WORLD, reqid+1);

      MPI_Irecv ( lrbytes, n, MPI_BYTE, right, ltag, MPI_COMM_WORLD, reqid+2);
      MPI_Irecv ( rrbytes, n, MPI_BYTE, left, rtag, MPI_COMM_WORLD, reqid+3);
      MPI_Waitall ( 4, reqid, status );

      t2 = MPI_Wtime() ;

      // print *, count(rrbytes .eq. "R"), count(lrbytes .eq. "L") what is the meaning of that sentence ?
      printf(" message length %d bytes transfer rate %lf  MB/s\n", n,1e-6 * (double)(2 * n * nprocs) / (t2-t1));

      //deallocate ( lsbytes, rsbytes, lrbytes, rrbytes )
      free(lsbytes);free(rsbytes);free(lrbytes);free(rrbytes);
      
    }
    else
    {
      //--------------- Slave part------------------------------------------------
      lbytes = (char *) calloc(n,sizeof(char)) ;
      rbytes = (char *) calloc(n,sizeof(char)) ;

      //allocate ( lbytes(1:n), rbytes(1:n) )
      for(i=0;i<n;i++)
      {
	lbytes[i] = ' ';
        rbytes[i] = ' ';
      }

      MPI_Irecv ( lbytes, n, MPI_BYTE, right, ltag, MPI_COMM_WORLD, reqid );
      MPI_Irecv ( rbytes, n, MPI_BYTE, left, rtag, MPI_COMM_WORLD, reqid+1 );
      MPI_Waitany ( 2, reqid, &ix, status);

      if ( ix == 0 )
      {
        MPI_Isend ( lbytes, n, MPI_BYTE, left, ltag, MPI_COMM_WORLD, reqid+2);
	MPI_Wait ( reqid+1, status);
        MPI_Isend ( rbytes, n, MPI_BYTE, right, rtag, MPI_COMM_WORLD, reqid+3);
	MPI_Wait ( reqid+3, status);
      }
      else if ( ix == 1 )
      {
        MPI_Isend ( rbytes, n, MPI_BYTE, right, rtag, MPI_COMM_WORLD, reqid+3);
	MPI_Wait ( reqid, status);
        MPI_Isend ( lbytes, n, MPI_BYTE, left, ltag, MPI_COMM_WORLD, reqid+2);
	MPI_Wait ( reqid+2, status);
      }
      else
      	MPI_Abort ( MPI_COMM_WORLD, 99);

      free(rbytes);
      free(lbytes);

    }
    //MPI_Barrier(MPI_COMM_WORLD);

  }

  //--------------------------------------------------------------------------------------

  //Shut Down MPI
  MPI_Finalize();

//end program asynchronous
}
