/* basic MPI program skeleton with
   MPI_Init, MPI_Comm_Rank, MPI_Comm_Size
   MPI_Get_processor_name, MPI_Barrier, MPI_Wtime
   MPI_Finalize */

// program hello

#include<stdio.h>
#include"mpi.h"

int	main(int  argc,char** argv)
{
     int          myrank, nprocs, n, i, islave, master, count;
     MPI_Status   status;
     int          ierr, resultlen, tag;
     char         hostname[MPI_MAX_PROCESSOR_NAME];
     double       t1, t2;


     // Initialize MPI
     MPI_Init(&argc, &argv);

     // Get my rank id and number of MPI processes
     MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
     MPI_Comm_size(MPI_COMM_WORLD, &nprocs);

     // Get hostname
     MPI_Get_processor_name(hostname, &resultlen);

     // Synchonization point
     MPI_Barrier (MPI_COMM_WORLD);

     // measure runtime
     t1 = MPI_Wtime();

  //-----------------------------------------------------------
  // Do work here ...
     printf("Hello! --- Rank %d out of %d processes running on %s\n",myrank, nprocs, hostname);

  //-----------------------------------------------------------

     // Synchronization point
     MPI_Barrier (MPI_COMM_WORLD);
     // measure runtime
     t2 = MPI_Wtime();
     printf("slave %d : %lf seconds\n", myrank, t2-t1);

     // Shut Down MPI
     MPI_Finalize();

//end program hello
}
