// generating one new communicator for all MPI processes running on the same host ..
// .. MPI_Comm_split, MPI_Comm_rank, MPI_Comm_size, MPI_Reduce
//program ex1f
#include<stdio.h>
#include<stdlib.h>
#include"mpi.h"

int	main(int  argc,char** argv)
{
     int          myrank, nprocs, n, islave, master=0;
     MPI_Status   status;
     int          ierr, resultlen, tag;
     int          color, new_rank, new_size, one, sum;
     MPI_Comm     new_comm;
     char         hostname[MPI_MAX_PROCESSOR_NAME];
     double       t1, t2;



     // Initialize MPI
     MPI_Init(&argc, &argv);

     // Get my rank id and number of MPI processes
     MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
     MPI_Comm_size(MPI_COMM_WORLD, &nprocs);

     // Synchonization point
     MPI_Barrier (MPI_COMM_WORLD);
     t1 = MPI_Wtime();

     // Get hostname
     MPI_Get_processor_name(hostname, &resultlen);
     printf("Rank %d out of %d processes running on %s\n",myrank, nprocs, hostname);

     /*our hostnames contain a number, which will be used to generate new
       communicators containing all MPI processes running on the same host.
       sunc<nn>.rz.rwth-aachen.de*/

     //read ( hostname(5:6),'(i2)') color
     color = atoi(&hostname[4]);

     MPI_Comm_split ( MPI_COMM_WORLD, color, myrank, &new_comm);
     MPI_Comm_rank ( new_comm, &new_rank);
     MPI_Comm_size ( new_comm, &new_size);

     one = 1;
     sum = 0;
     MPI_Reduce ( &one, &sum, 1, MPI_INT, MPI_SUM, 0, new_comm);
     if ( new_rank == 0 )
        printf("my rank in MPI_COMM_WORLD is %d out of %d / my rank in new_comm is %d out of %d / %d processes have been taking part in the reduction\n",myrank,nprocs,new_rank,new_size,sum);


    //-----------------------------------------------------------------------------------------------

    // Synchronization point
    MPI_Barrier (MPI_COMM_WORLD);
    t2 = MPI_Wtime();
    printf("slave %d : %lf seconds\n", myrank, t2-t1);

    // Shut Down MPI
    MPI_Finalize();

//end program ex1f
}
