// measuring the bandwidth when sending messages in a ring ..
// .. MPI_Send, MPI_Recv
//program ring

#include<stdio.h>
#include<stdlib.h>
#include"mpi.h"
#define TRUE 1

int	main(int  argc,char** argv)
{
     int          myrank, nprocs, n, i, islave, master=0, count;
     MPI_Status   status;
     int          ierr, resultlen, tag;
     int          left, right;
     char         hostname[MPI_MAX_PROCESSOR_NAME];
     double       t0, t1, t2;
     char	  *bytes;
     // character (LEN=1), allocatable, dimension(:) :: rsbytes, lsbytes, rrbytes, lrbytes, lbytes, rbytes

     // Initialize MPI
     MPI_Init(&argc, &argv);

     // Get my rank id and number of MPI processes
     MPI_Comm_rank(MPI_COMM_WORLD, &myrank);
     MPI_Comm_size(MPI_COMM_WORLD, &nprocs);

     t0 = MPI_Wtime() ;

     //!-----------------------------------------------------------
     //! Do work here ...

     left  = (nprocs + myrank - 1) % nprocs;
     right =  (myrank + 1) % nprocs;
     tag = 23;
     printf("myrank= %d left neighbor= %d rigth neighbor= %d\n", myrank,left,right);
     MPI_Barrier ( MPI_COMM_WORLD );

     while(TRUE)
     {
     	// The master reads an integer number form standard input and sends it to all slaves
        if ( myrank == master )
        { //----------------------- Master part-----------------------------------
          printf("Number of bytes ? (0 quits, max %d = 128MB\n",1024*1024*128);
          scanf("%d",&n);
        }

    	MPI_Bcast ( &n, 1, MPI_INT, master, MPI_COMM_WORLD);
    	if ((n <= 0) || (n > 1024*1024*128 ))
	     break;

        bytes = (char *) calloc(n,sizeof(char)) ;
	for(i=0;i<n;i++)
       	   bytes[i] = 'x';

        if( myrank == 0 )
	{ //----------------------- Master part------------------------------------
      	   t1 = MPI_Wtime();
           MPI_Send ( bytes, n, MPI_BYTE, right, tag, MPI_COMM_WORLD);
           MPI_Recv ( bytes, n, MPI_BYTE, left, tag, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
           t2 = MPI_Wtime();
           printf(" message length %d bytes transfer rate %lf  MB/s\n", n,1e-6 * (double)(2 * n * nprocs) / (t2-t1));
	}
        else
	{ //---------------------- Slave part--------------------------------------
           MPI_Recv ( bytes, n, MPI_BYTE, left, tag, MPI_COMM_WORLD, MPI_STATUS_IGNORE);
           MPI_Send ( bytes, n, MPI_BYTE, right, tag, MPI_COMM_WORLD);
        }

        free( bytes );
     }

  // -------------------------------------------------------------------------------

     // Shut Down MPI
     MPI_Finalize();

//end program ring
}
