!! a simple server/client example with 
!!  MPI_Lookup_name, MPI_Comm_connect
!!  both server and client executables must be build, see server
!!  Note: - gmake server-client to build
!!        - manually: run server and client on different xterms 
        

program main
implicit none

include 'mpif.h'

integer procnum, rank
integer :: IERROR, NEWCOMM
integer :: status(MPI_STATUS_SIZE)
integer :: DISCONNECT

character (len = 11) :: service_name                !published service name
character (len = MPI_MAX_PORT_NAME) :: PORT_NAME    !address = host:port
character (len = 256) :: message

service_name = "test_server"
DISCONNECT = 101                                      ! message tag for disconnection

call MPI_INIT(IERROR)

call MPI_COMM_RANK(MPI_COMM_WORLD, rank, IERROR)
call MPI_COMM_SIZE(MPI_COMM_WORLD, procnum, IERROR)

write (message, *)  "Hello server, message from : Client (rank)", rank

print *, "Client ", rank+1, " of ", procnum, ": ", "initialzing MPI" 

print *, "Client ", rank+1, " of ", procnum, ": ", "service name -> ", service_name
write (*, '(A, I1, A, I1, A, A)', ADVANCE = 'NO' ) " Client ", rank+1, " of ", procnum, ": ", "looking up port name ... " 

                                                           ! find port associated with a service name
call MPI_LOOKUP_NAME(service_name, MPI_INFO_NULL, PORT_NAME, IERROR)
print *, " OK port name -> ", PORT_NAME

write (*, '(A, I1, A, I1, A, A, A)', ADVANCE = 'NO' ) " Client ", rank+1, " of ", procnum, ": ", "trying to connect server @",  & 
PORT_NAME
                                                           ! establishes communication with server
call MPI_COMM_CONNECT(PORT_NAME, MPI_INFO_NULL, 0, MPI_COMM_WORLD, NEWCOMM, IERROR)
print *, " ...   OK communication established"

                                                            ! send a greeting message
write (*, '(A, I1, A, I1, A, A)', ADVANCE = 'NO' ) " Client ", rank+1, " of ", procnum, ": ", "sending a greeting message ..."
call MPI_SEND(message, len(message), MPI_CHARACTER, 0, 100, NEWCOMM, IERROR)
print *, " OK message sent"

call MPI_BARRIER(MPI_COMM_WORLD, IERROR)                          ! wait for all to finish comm.
                                                             ! then disconnect from server
if ( rank == 0) then
    message = "disconnect"
    write (*, '(A, I1, A, I1, A, A)', ADVANCE = 'NO' ) " Client (Master): sending disconnection request ..."
    call MPI_SEND(message, len(message), MPI_CHARACTER, 0, DISCONNECT, NEWCOMM, IERROR)
    print *, " disconnected"
end if

call MPI_COMM_DISCONNECT(NEWCOMM, IERROR)
call MPI_FINALIZE(IERROR)
end program









