!! a simple server/client example with 
!!  MPI_Open_port, MPI_Publish_name, MPI_Comm_accept, MPI_Comm_disconnect
!!  both server and client executables must be build, see client
!!  Note: - gmake server-client to build
!!        - manually: run server and client on different xterms 
        
program main
implicit none

include 'mpif.h'

integer :: IERROR, NEWCOMM
integer :: status(MPI_STATUS_SIZE)
integer :: DISCONNECT

character (len = 11) :: service_name                !published service name 
character (len = MPI_MAX_PORT_NAME) :: PORT_NAME    !address = host:port
character (len = 256) :: message


service_name = "test_server"
DISCONNECT = 101                                      ! message tag for disconnection

print *, "Server: initializing MPI"
call MPI_INIT(IERROR)
                                                    ! establishes a network address to  
                                                    ! accept connections from clients
call MPI_OPEN_PORT(MPI_INFO_NULL, PORT_NAME, IERROR)
print *, "Server: port name ->", PORT_NAME
                                                     ! publish the service name thats
                                                     ! associated with the port
call MPI_PUBLISH_NAME(service_name, PORT_NAME , IERROR)
print *, "Server: service name published -> ", service_name 
                                                     ! establishes communication with a client,
LOOP1: do while (.TRUE.)                             ! return an intercommunicator that allows comm.    
   print *,"Server: accepting connections ... "      ! with the clients
   call MPI_COMM_ACCEPT(PORT_NAME, MPI_INFO_NULL, 0, MPI_COMM_WORLD, NEWCOMM, IERROR)

   LOOP2: do while (.TRUE.)
      call MPI_RECV(message, len(message), MPI_CHARACTER, MPI_ANY_SOURCE, MPI_ANY_TAG,NEWCOMM, status, IERROR)
      print *, "Server: message received ->"
      print *, message
                                                      ! check whether clinet wants to 
                                                      ! disconnect 
      if ( status(MPI_TAG) == DISCONNECT ) then
          write(*,'(A)', ADVANCE = 'NO' ) "Server: disconnection request from clinet ->"
          call MPI_COMM_DISCONNECT(NEWCOMM, IERROR)
          print *, "disconnected"
          exit LOOP2
       end if
    end do LOOP2
 
end do LOOP1

call MPI_FINALIZE(IERROR)
end program
